VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Alpha & Omega Updater"
   ClientHeight    =   5835
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   3285
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5835
   ScaleWidth      =   3285
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   2040
      TabIndex        =   7
      Top             =   120
      Width           =   1095
   End
   Begin VB.ListBox lstUpList 
      Height          =   840
      Left            =   5160
      TabIndex        =   6
      Top             =   1440
      Width           =   3135
   End
   Begin VB.TextBox txtLog 
      Height          =   1455
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   4
      Top             =   3960
      Width           =   3015
   End
   Begin VB.CommandButton cmdUpdate 
      Caption         =   "Begin Update"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1815
   End
   Begin anoUpdater.FileDownloader FileDownloader 
      Left            =   3240
      Top             =   120
      _ExtentX        =   1799
      _ExtentY        =   1667
   End
   Begin VB.Timer Timer1 
      Interval        =   500
      Left            =   5160
      Top             =   3960
   End
   Begin VB.ListBox lstFiles 
      Height          =   2595
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   3015
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Center
      Caption         =   "Status..."
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   5520
      Width           =   3015
   End
   Begin VB.Label Label2 
      Caption         =   "Log"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   3720
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "Files to download"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   2655
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
'for reading and writing INI files

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_SHOWNORMAL = 1
'for running files n such


Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
'for detecting if ano is open

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Const LB_FINDSTRINGEXACT = &H1A2
'Private Const LB_SELECTSTRING = &H18C
'api used to find strings in listboxes

Dim theServer As String

Dim DownloadingFile As Boolean
Dim cancelDownload As Boolean
Dim Part2 As Boolean

Private Sub cmdCancel_Click()
    If DownloadingFile Then LogText "Canceling update..."
    cancelDownload = True
End Sub
'cancel the update

Private Sub cmdUpdate_Click()
'On Error GoTo Err

    cmdUpdate.Enabled = False
    cancelDownload = False
    DownloadingFile = False
    lstFiles.Clear
    lstUpList.Clear
    'reset
    LogText "- Downloading version info..."
    '
    DownloadingFile = True
    FileDownloader.DownloadFile theServer & "currentversion.txt", App.Path & "\ver_currentversion.txt"
    Do Until Not DownloadingFile
        DoEvents
    Loop
    'download the current version
    If cancelDownload Then GoTo Err
    'if canceling then exit
    Dim tmpINI As String, currentVersion As String, myVersion As Long
    tmpINI = GetINI("Updater", "Version", "100034")
    myVersion = Val#(tmpINI)
    'if not specified assume version is 100034, since thats lowest version that supports this updater
    If myVersion < 100034 Then myVersion = 100034
    'we assume the user has tampered with the ini
    Dim fileData As String, newVersion As Long
    Open App.Path & "\ver_currentversion.txt" For Input As #1
    Do Until EOF(1)
    Line Input #1, fileData
        newVersion = Val#(fileData)
        If newVersion > myVersion Then
            LogText "- Downloading file list..."
        'is a new version
        Else
        'user is up to date
            LogText "- You are up to date."
            GoTo Err
        End If
    Loop
    Close #1
    'check if there actually is an update
    DestroyFile App.Path & "\ver_currentversion.txt"
    'delete
    Dim arrIndex As Long
    'if were this far then theres new files
    For arrIndex = (myVersion + 1) To newVersion
        lstUpList.AddItem arrIndex & ".txt"
    Next arrIndex
    'this makes a list of changed files to read. it reads each
    'newer version from current and downloads the changed files, then adds them to a list of files
    'to be downloaded
    Dim theSplit() As String, arrIndex2 As Integer, tmpDir As String, tmpDir2 As String, stringLoc As Integer
    '
    For arrIndex = 0 To (lstUpList.ListCount - 1)
        DownloadingFile = True
        FileDownloader.DownloadFile theServer & "changelogs/" & lstUpList.List(arrIndex), App.Path & "\ver_" & lstUpList.List(arrIndex)
        'start download
        Do Until Not DownloadingFile Or cancelDownload
            DoEvents
        Loop
        'download each
        If cancelDownload Then GoTo Err
        'if canceling then exit
        Open App.Path & "\ver_" & lstUpList.List(arrIndex) For Input As #1
        Do Until EOF(1)
            Line Input #1, fileData
                theSplit = Split(fileData, ChrW$(10))
                '
                For arrIndex2 = 0 To UBound(theSplit)
                    tmpDir2 = vbNullString
                    'reset
                    If LenB(theSplit(arrIndex2)) Then
                    'if not null
                        tmpDir = theSplit(arrIndex2)
                        stringLoc = InStr(tmpDir, "\")
                        Do Until stringLoc = 0
                            tmpDir2 = tmpDir2 & Left$(tmpDir, stringLoc)
                            makeDirectory App.Path & "\" & tmpDir2
                            'create
                            tmpDir = Mid$(tmpDir, stringLoc + 1)
                            'parse
                            stringLoc = InStr(tmpDir, "\")
                        Loop
                        'create directories
                        If SendMessage(lstFiles.hwnd, LB_FINDSTRINGEXACT, 0, theSplit(arrIndex2)) = -1 Then lstFiles.AddItem theSplit(arrIndex2)
                        'add to download list if not there alrdy
                    End If
                    'if entry isnt null
                Next arrIndex2
        Loop
        Close #1
        'read the file
        DestroyFile App.Path & "\ver_" & lstUpList.List(arrIndex)
        'delete
    Next arrIndex
    '
    LogText "- Downloading needed files..."
    
    Do Until lstFiles.ListCount = 0 Or cancelDownload
    'get all files
        DownloadingFile = True
        FileDownloader.DownloadFile theServer & "files/" & lstFiles.List(0), App.Path & "\" & Replace$(lstFiles.List(0), "/", "\")
        'overwrite files
        Do Until Not DownloadingFile Or cancelDownload
            DoEvents
        Loop
        'dl
        If cancelDownload Then GoTo Err
        'if canceling then exit
        If LCase$(Right$(lstFiles.List(0), 4)) <> ".exe" Then RewriteFile App.Path & "\" & Replace$(lstFiles.List(0), "/", "\")
        'remove returns
        lstFiles.RemoveItem 0
        'remove entry
    Loop
    'download all files needed
    LogText "- Updates complete!"
    '
    Timer1.Interval = 1000
    Timer1.Enabled = True
    
Err:
    If cancelDownload Then LogText "- Download did not complete properly...user cancelled or an error has occured."
    cmdUpdate.Enabled = True
    
End Sub

Private Sub FileDownloader_DowloadComplete()
    
    DownloadingFile = False
    
End Sub

Private Sub FileDownloader_DownloadErrors(strError As String)
    
    DownloadingFile = False
    cancelDownload = True
    LogText "- Error: " & strError
    
End Sub

Private Sub FileDownloader_DownloadProgress(intPercent As String)
    
    lblStatus = "Downloaded: " & intPercent & "%"

End Sub

Private Sub DestroyFile(ByRef theFile As String)
On Error GoTo Err
    Kill theFile
Err:
End Sub
'deletes a file

Private Sub RewriteFile(ByRef theFile As String)
Dim Buffer As String

    Open theFile For Binary As #2
    Buffer = Space$(LOF(2))
    Get #2, 1, Buffer
    'load into memory
        Buffer = Replace$(Buffer, ChrW$(10), vbCrLf)
        Buffer = Replace$(Buffer, ChrW$(13), vbCrLf)
    Close #2
    'load into memory, replace 10s with vb returns
    Open theFile For Binary As #2
    Put #2, 1, Buffer
    Close #2
    'print file
    
End Sub












Private Sub makeDirectory(ByRef thePath As String)
On Error GoTo Err
    MkDir thePath
Err:
End Sub



Private Sub Form_Load()

    If App.PrevInstance Then End
    'exit if open alrdy
    theServer = "www.radracer.us/otp/update_checks/ano/"
    'default server
    If GetINI("Updater", "UpAvail", 0) = 0 Then End
    'if no update is available (signified by the bot) then end
        
    LogText "- Waiting for Alpha & Omega to close..."
    
End Sub

Private Sub LogText(ByRef theText As String)
    
    txtLog.Text = txtLog.Text & theText & vbCrLf
    txtLog.SelStart = Len(txtLog.Text)
    
End Sub
'add to action log


Private Function GetINI(Section As String, Key As String, Optional writeNulls As String) As String
Dim ret As String, NC As Long
    
    ret = String(100, 0)
    NC = GetPrivateProfileString(Section, Key, Key, ret, 100, App.Path & "\Text\someChatConfig.ini")
     
    If NC <> 0 And Left$(ret, NC) <> Key Then
      ret = Left$(ret, NC)
    Else
      ret = vbNullString
    End If
    GetINI = ret '
    GetINI = Trim$(GetINI) 'removes spaces from submitting numbers as strings
    If LenB(writeNulls) And LenB(GetINI) = 0 Then GetINI = writeNulls
    'if enabled and entry is null set to 0 to prevent erroring
  
End Function
'gets a INI result

Private Sub Timer1_Timer()
Static CountUp As Byte

    If Not Part2 Then
        If FindWindow(vbNullString, "ano_updating_now") = 0 Then
            Timer1.Enabled = False
            cmdUpdate.Enabled = True
            LogText "- You may select update now."
            '
            Part2 = True
        End If
    'check for the closing of a&o
    Else
        LogText "- Launching Alpha & Omega in " & (7 - CountUp)
        CountUp = CountUp + 1
        If CountUp = 8 Then
            Timer1.Enabled = False
            Me.Hide
            '
            ShellExecute Form1.hwnd, vbNullString, App.Path & "\Alpha & Omega.exe", vbNullString, "C:\", SW_SHOWNORMAL
            '
            Unload Me
        End If
        'launch a&o
    End If
    
End Sub
