Attribute VB_Name = "War3_SCLogin"


Option Compare Binary
Option Explicit


Public FormsOpen As xyzForms
Private Type xyzForms
    Access As Boolean 'if true then is open
    ClanCreator As Boolean ' if true then is open
    Config As Boolean 'if true then is open
    Filters As Boolean 'if true then is open
    Profile As Boolean 'if true then is open
End Type
'type used for which forms are open

Public Moderation As xyzModeration
Private Type xyzModeration
    CPTick As Currency 'last time cp was set on or off
    Shitlist(4) As String '4 is reserved for unknown realms, 0-3 is west east europe asia
    tagBans(4) As String 'same as shitlist
End Type
'contains our shitlist, tagbans, ect

Public ChannelList() As xyzChannelList
Private Type xyzChannelList
    Username As String
    ClanTag As String
    IconNumber As Byte
    ObtainedOps As Boolean
    AlignTop As Boolean
    Client As String
    FilterMarks As Integer
End Type

Public botElements As xyzElements
'workable version
Private Type xyzElements
    AccessAdders As String 'contains who added who with access
    AccessUsers As String 'string of users with access
    AccountActivity As Boolean 'save pw changes registers ect
    ActiveChatIndex As Integer 'index the user is viewing
    ActivePing As Long 'the active ping of the bot owner
    AutoCompleteWhispers As Boolean 'if true when attempt to complete /w partials
    BnlsServer As String 'bnl s   ser ver to connect to
    Buzz As Boolean 'if true users w/ access can use the buzz  alert ect command
    CDKeys() As String 'load our keys into this when the config is open, and destroy when config is closed
    CDKeysExpansion() As String 'load our expansion keys into this when the config is open, and destroy when config is closed
    ChatColors As Boolean 'disable these features if true
    ChatPaused As Boolean 'if true then chat is paused
    ChatPausedIndex As Integer 'index of profile paused
    ConnectList As String 'contains indexes of profiles to be connected
    ConnectTick As Currency 'last tick since a bot tried to connect
    CurrentActivePingTick As Currency 'same as self ping except issue when idle
    CurrentActivePingIndex As Integer 'index sending active ping
    FiltersBlockDuplicates As Boolean 'if true then block all chat from # names
    FiltersClientDeductable As Boolean 'didnt know what else to name this... but if enabled then the user gets less of a random load marks against them depending on their client
    FiltersDisableJoinLeaves As Boolean 'if true then do not show any joins or leaves while filters are triggered
    FiltersInMessages() As String 'filtered messages
    FiltersSquelchLoads As Boolean 'if true ignore loads during idle times
    FiltersOut() As String 'outgoing filters
    FiltersLastName As String 'the name of the last person filtered. this is used to prevent extra work on other profiles in same channel
    FiltersLastTick As Currency 'tick of when the last name was filtered, this is associated with the above.
    Hyperlinks As Boolean 'disable these features if true
    Invites As Boolean 'if true announce invites rather than echo them
    JoinLeaves As Boolean 'display join and leave chat
    LastChatIndex As Integer 'one before active, used in reference of unloading a profile
    LVState As Byte '0 channel 1 clan 2 friendslist ect
    MailMemoTick As Currency 'tick since last memo received or mail sent.
    MailNotified As String 'this holds a list of ppl that have been notified they have mail. if theyre in this list then dont send notice. clear this list every 60s
    MailUsers(4) As String 'users that will be getting mail, realm specific
    MailWithoutAccess As Boolean 'wether or not a user requires access to mail
    MinimalView As Boolean 'if true use smaller textboxes n such
    Memos As Boolean 'wether or not allow !memo msg
    MemoRecieved As Boolean 'if true then memos await reading
    PingWest As Currency 'tickcounts used to determine when a server was last pinged to gather a current ip
    PingEast As Currency 'tickcounts used to determine when a server was last pinged to gather a current ip
    PingEurope As Currency 'tickcounts used to determine when a server was last pinged to gather a current ip
    PingAsia As Currency 'tickcounts used to determine when a server was last pinged to gather a current ip
    PreviewProfile As Boolean 'if true display the preview window
    ProfileOnTab() As Integer 'stores which profile is on which tab
    RecentWhispers(2) As String 'stores recently received whispers
    RotateCDKeys As Boolean 'if true rotate CDkey
    ProxyList() As String 'proxies
    SafelistAccess As Boolean 'if true let users w/ <10 access but > 0 use basic commands
    SelfIcons As Boolean 'if true use self icons
    ServerWest As String 'used for new custom server ips in 057 release
    ServerEast As String 'used for new custom server ips in 057 release
    ServerEurope As String 'used for new custom server ips in 057 release
    ServerAsia As String 'used for new custom server ips in 057 release
    TimeText As String 'time format, ie:  mm hh ss ect
    TimeLeft As String 'left of time
    TimeRight As String 'right of time
    txtSendFocus As Boolean ' if true then txt send has focus
    UserlistPainted As Boolean 'if true a name is already selected
    UserlistRepaint As Boolean 'if true then repaint the userlist no matter what
    UserlistSelectedIndex As Integer 'index of last select
    UserlistSelectedUsername As String 'username of last select
    QueueNext As Integer 'next profile to run
    VerbyteD2 As String 'verbytes
    VerbyteW2 As String 'verbytes
    VerbyteW3 As String 'verbytes
    VerbyteSC As String 'verbytes
    UpdatesProcessed As Byte ' if 0 automatics not checked, if 2 automatics checked, if 3 remote note checked, if 5 remove checked
    UpdatesUsername As String ' holds index, whisperstring + name, and if to echo
    WhisperWindow As Byte '0 off 1 bottom 2 top
End Type
'general data

Public aProfile() As xyzProfile
'sets our type as an array for multiple profiles
Private Type xyzProfile
    AccessAdders As String 'contains who added who with access
    AccessTrigger As String '1 char trigger
    AccessUsers As String 'actual accesslist
    AccessUnique As Boolean 'if true then read from accessusers instead of global
    Active As Boolean 'profile should be connecting or connected(true)
    AutoCP As Boolean 'if enabled cp on filters and off when they disable
    AutoSquelchQueued As Boolean 'if true an auto iggy is in queue
    BNETProfileLookupName As String 'the profile being looked up with / profile
    BNETRealm As Byte 'realm id that this profile is on
    BNETServer As String 'bnet server connecting to
    bnlsChecksumResult As Long 'same checksumResult in parse 0 x 50 except through bnls
    bnlsConnected As Boolean 'connected to bnls server
    bnlsEnabled As Boolean 'use bnls
    bnlsEXEinfo As String 'exe date n such
    bnlsEXEversion As Long 'exe version
    'bnlsProductVerbyte As String 'verbyte of connecting product
    bnlsTimeoutTick As Currency 'gettick count check
    CDKey As String 'cdkey for profile
    CDKeyExpansion As String 'for d2 expan or w3 expan
    Channel As String 'channel profile is in
    ChannelClanTag As String 'holds the clan tag of current channel the bot is in. this is used to safelist clan members
    ChannelHome As String 'home channel
    ChannelUsers As String 'this is a temp string, used to preserve ticks
    ChatSelfTimestamp As Boolean 'if true then color next timestamp a diff color
    ChatIconChanged As Boolean 'handles change* of tab icon
    ClanTag(1) As String 'holds name(0) and tag(0) so we can recover tag on updating flags
    ColorSelstart As Long 'place in rtb to check colors
    CommandTick As Currency 'safelisted users will be allowed to use certain commands every x seconds
    ConnectOnLoad As Boolean 'loads bots on startup if true
    ClanArray(3) As String 'used for clan creation and joining recieved invites
    ClientBans As String 'stored clients to ban on clientban
    ClientToken As Long 'logon item
    Connected As Boolean 'is connected to bnet
    Email1 As String '
    Email2 As String 'this requires email1 to be set, and it will then attempt to change recovery email
    FilterWhisperTick As Currency 'used to track whisper spams tick
    FilterWhisperCount As Byte 'used to track whisper spam count
    FilterWhisperTriggered As Boolean 'if true whisper flood detected
    FilterJoinName As String 'name to join last
    FilterJoinTick As Currency 'time joined
    FilterCount As Long 'the amount of items that have been filtered
    FilterHideBans As Boolean 'if true then hide bans
    FilterNameIgnored As String 'name of the user being ignored and the tick
    FilterRandomJoins As Byte 'the amount of users marked as random that join in a row
    FilterRandomTick As Currency 'last tick for when a random user joined
    FilterSafeName As String 'if contains data this name will be excluded from filter checks. used to halt checks on d d p and such
    FilterResetTick As Currency 'how long since last flood detection, used for auto on/off
    FilterTriggered As Boolean 'if true then flood is triggered and notice has been sent
    FlagUpdateTick As Currency 'used to temp store the users in channel tickcount on flag updates
    GuardLevel As Byte 'level of security, 0 13 or 22
    GuardLoadBan As Boolean 'if true then auto loadban
    GameClient As String 'client
    GreetJoinMessage As String 'msg of greet (join)
    GreetLeaveMessage As String 'msg of leave greet, auto add / w  name
    GreetResetCount As Byte 'when this reaches 15 scan the list and delete greeted users past 2 hours
    IdleMEnabled As Boolean 'idle enabled
    IdleMCount As Byte 'x of X idle time complete
    IdleMInterval As Byte 'every x minutes
    IdleMType As Byte 'uptime ect
    IdleMMessage As String 'null out if not this type
    IdleUsersGrayed As String 'users in this string are idle, we reset thing string and rebuild the idle list every time a profile is changed
    ManualEntryTick As Currency 'last tickcount of when a non auto00x entry was added to the queue
    UnIgnoreTick As Currency 'tick of when user was last unignored. this is to prevent multiple unignores of the same person
    LastWhisperName As String 'last user to whisper this profile
    LinkData() As String 'link data array
    LinkSelstart As Long 'where to start checking for links
    Loaded As Boolean 'tab already exist and such
    Lockdown As Boolean 'if true and is operator ban anyone without access
    Logging As Boolean 'if true then log
    ModLastName As String 'last name checked to auto ban
    ModLastTick As Currency 'last time shitlist/tagbans were checked
    MP3Name As String 'stores the mp3 name from an idle
    Name As String 'username
    NewPass As String 'if not vbnullstring change pass
    NLS As Long 'logon item
    OldNLS As Long 'logon item
    Operator As Boolean 'true if self is op
    OperatorList As String 'contains list of operators to run numerous checks on
    Packet50Sent As Boolean 'if you get to packet 0x50 then this becomes true. its to determine ipban or not
    PacketTimeout As Currency 'tick of last received packet. used to stop auto reconnect on slow connects
    Password As String 'password to username
    PingType As Byte 'negative one, zero, zero plugged ect
    PreviewProfile As Boolean 'if true then relay this profile to the preview rtb, if its enabled in botelements
    profilePath As String 'path of the ini attached to this profile
    Proxy As Boolean 'if not vbnullstring connect to this proxy
    ProxyHTTP As Boolean 'if true connect using HTTP
    QueueLastLength As Integer 'length of last sent
    QueueRaiseFactor As Byte 'higher = longer wait
    QueueRaiseFactorTick As Currency 'controls raisefactor drop ammount n such
    QueueSharing As Boolean 'if true then share queue with other bots in same channel on ops
    QueueWaitTick As Currency 'wait until next queue run
    RealClan As String 'clan theyre in
    RealName As String 'unique name
    RealNameConverted As String 'unique name with realm
    RealPing As Long 'unique ping
    ReconnectCount As Long 'times tried to r/c -- you never know..
    ReconnectTick As Currency 'last reconnect try
    RecoveryEmail As String ' if not null then try to recover the account
    ServerToken As Long 'logon item
    Socksified As Boolean 'socks use granted (proxy), auto true if not using a proxy
    SpamGuardReconnectStart As Long 'this holds the selstart of the reconnect after one has failed
    SpamGuardErrorMessage As String 'holds the last error message, if is same as current and user is voided then don't show it
    StrBuffer As String 'for data parsing
    Sweepban As Byte '0 for not enabled, 1 ban, 2 ipban
    TabHidden As Boolean 'if true then the tab is not visible
    UptimeTick As Currency 'uptime basically
    War3Rank As Byte '0 new peon, 1 peon, 2 grunt,3 shaman, 4 chieftain
    Whisperback As Boolean 'if true whisper back all commands except version
'  WardenKeyOut() As Byte 'warden keycodes  'w// warden code
'  WardenKeyIn() As Byte 'warden keycodes
'  WardenPacket As String 'packet to send out on the 60s timer
'  WardenOutTime As String 'keeps tracks of ins and outs for profile, display purposes only
'  WardenInTime As String 'keeps tracks of ins and outs for profile, display purposes only
End Type
'login data
'Private cWarden         As New Warden
'w// -- remember to add Warden.cls to the project



Public Sub ParseBNCS(ByRef Index As Integer)
    
    Dim PacketID As Byte

    With PBuffer
        .GetLenSTRING 1 'junk
        PacketID = Asc(.GetLenSTRING(1)) 'packet id
        .GetLenSTRING (2) 'skip past packet header
    End With
    'prep packet
        
    If Not aProfile(Index).Connected Then
        aProfile(Index).PacketTimeout = GTC
        '
        Select Case PacketID
            Case &H4C, &HF, &H7D, &H7F, &H75, &H7A, &HA, &H59, &H4E, &H50, &H46, &H25
            'ones to ignore
            Case Else
                AddChat 0, Index, vbGreen, "Packet <- Recieved 0x" & Hex(PacketID) & "."
        End Select
    End If
  'shows packet recieved
  'coded by Fleet-
  
    Select Case PacketID
        Case &H0:              PBuffer.sendPacket &H0, Index 'stay alive
        Case &HA:              Parse0x0A Index 'final login packet
        Case &HF:              Parse0x0F Index 'standard joins leaves talk ect
        Case &H19:             Parse0x19 Index 'message box, likely flooded out
        Case &H25:             If aProfile(Index).Connected Then frmMain.wS(Index).SendData PBuffer.GetInboundData
        Case &H26:             Parse0x26 Index 'profile request
        Case &H31:             Parse0x31 Index 'account password change reply (sc)
        Case &H3A:             Parse0x3A Index 'login reply (sc)
        Case &H3D:             Parse0x3D Index 'account creation reply (sc)
        Case &H41:             Parse0x41 Index 'ad reply, used for active ping
        Case &H46:             Parse0x46 Index 'last logons, key status, ect
        Case &H4E:             Parse0x4E Index 'wcg reply of some sort
        Case &H50:             Parse0x50 Index 'send key hash sc/w3
        Case &H51:             Parse0x51 Index 'key hash reply
        Case &H52:             Parse0x52 Index 'account creation reply (w3)
        Case &H53:             Parse0x53 Index 'login auth (w3)
        Case &H54:             Parse0x54 Index 'login auth proof (w3)
        Case &H55:             Parse0x55 Index 'pass change auth (w3)
        Case &H56:             Parse0x56 Index 'pass change auth proof (w3)
        Case &H59:             RegisterAccountEmail Index 'send registration email
        'Case &H5E:             Parse0x5E Index 'w// warden packet -- remember to add warden.cls to the project
        Case &H65:             Parse0x65 Index 'friends list parsing
        Case &H70:             Parse0x70 Index 'clan tag availability checking
        Case &H72:             Parse0x72 Index 'clan creation invites (recieved invite from bla)
        Case &H73:             Parse0x73 Index 'clan disban reply
        Case &H74:             Parse0x74 Index 'clan chieftain change reply
        Case &H75:             Parse0x75 Index 'clan w3 user (self) is in, and rank
        Case &H77:             Parse0x77 Index 'invite acceptance reply
        Case &H78:             Parse0x78 Index 'clan member removal status
        Case &H79:             Parse0x79 Index 'clan invitation recieved
        Case &H7A:             If botElements.LVState = 1 Then frmMain.cmdClan_Click 'clan rank change
        Case &H7C:             Parse0x7C Index 'clan motd request reply
        Case &H7D:             Parse0x7D Index 'clan member list
        Case &H7E:             Parse0x7E Index 'clan member removal status
        Case &H7F:             Parse0x7F Index 'clan member status update
        Case &H66, &H67, &H68, &H69: If botElements.LVState = 2 Then PBuffer.sendPacket &H65, Index 'frmMain.cmdFriends_Click 'update friends list with new data
        Case &HB, &H4C, &H81:  'packets-to-ignore channel list, required work, clan member rank change
        Case Else:          ' AddChat 0, Index, vbYellow, GetSTRING(62) & Hex(PacketID) 'Notice --- Unhandled BNET packet, &H
    End Select


End Sub
'handles packets to said functions/subs

Private Sub Parse0x7C(ByRef Index As Integer)

    Dim EchoCommand As Boolean
    If aProfile(Index).ClanArray(3) = "1" Then EchoCommand = True
    '
    With PBuffer
        .GetDWORD
        .GetDWORD
        QueueString GetString(229) & .GetNTstring, Index, EchoCommand
    End With
    
End Sub
'handles motd request reply

Private Sub Parse0x78(ByRef Index As Integer)

    Dim EchoCommand As Boolean
    If Left$(aProfile(Index).ClanArray(3), 1) = "1" Then EchoCommand = True
    '
    PBuffer.GetDWORD 'cookie
    Select Case Asc(PBuffer.GetLenSTRING(1))
        Case 0: QueueString GetString(113) & Mid$(aProfile(Index).ClanArray(3), 2) & GetString(225), Index, EchoCommand 'String225=] has been removed from the clan.
        Case Else: QueueString GetString(113) & Mid$(aProfile(Index).ClanArray(3), 2) & GetString(226), Index, EchoCommand 'String226=] could not be removed from the clan.
    End Select

End Sub
'clan member removal status


Private Sub Parse0x7F(ByRef Index As Integer)

    With PBuffer
        If .GetNTstring() = aProfile(Index).Name Then
            aProfile(Index).War3Rank = Asc(.GetLenSTRING(1))
        End If
        'if name is that of this profile, set the profiles rank that of which indicated in this packet
    End With

End Sub
'received when a clan members rank or status has changed

Private Sub Parse0x74(ByRef Index As Integer)

    With PBuffer
        .GetDWORD 'cookie
        Select Case Asc(.GetLenSTRING(1))
            Case &H0
            'sucess
                If botElements.LVState = 1 And Index = botElements.ActiveChatIndex Then
                    PBuffer.InsertDWORD 0
                    PBuffer.sendPacket &H7D, Index
                    'refresh clan list
                End If
                'if clanlist is showing then update
            Case &H1, &H2, &H4, &H5, &H7, &H8: 'failed
            Case Else: 'unknown reply
        End Select
    End With
        
End Sub
'chieftain change reply

Private Sub Parse0x46(ByRef Index As Integer)
Dim EntryCount As Byte
Dim theTimestamp As Long

    With PBuffer
        EntryCount = Asc(.GetLenSTRING(1))
        .GetDWORD 'last logon  but not needed as its displayed in the message.
        .GetDWORD 'oldest news timestamp
        .GetDWORD 'newest news timestamp
    
        Dim arrIndex As Long, theMessage As String
        Dim messageSplit() As String, messageIndex As Long, theColor As Long
        '
        Dim KeySet As Boolean
        'if true then already attempted to set a new key
        For arrIndex = 1 To EntryCount
            theTimestamp = .GetDWORD
            theMessage = .GetNTstring
            If theTimestamp = 0 Then
                messageSplit() = Split(theMessage, ChrW$(10))
                For messageIndex = 0 To UBound(messageSplit)
                    If LenB(messageSplit(messageIndex)) Then
                        If InStrB(messageSplit(messageIndex), "account is muted.") Or InStrB(messageSplit(messageIndex), "chat privileges suspended") Then
                            KeySet = True 'if true issue a key rotate
                            'im not sure what the reply would be if the expansion key was muted or voided.
                            'probably the same thing which would be a problem, so since im lazy im going
                            'to pretend i didnt consider this and ... what was I saying...?
                            theColor = vbRed
                        'warning color
                        Else
                        'normal color
                            If InStrB(messageSplit(messageIndex), "Failed logon attempts since then:") Then
                                theColor = &HFFFFC0
                            Else
                                theColor = &H57CFE3
                            End If
                        End If
                        AddChat 0, Index, theColor, messageSplit(messageIndex)
                    End If
                Next messageIndex
            End If
        Next arrIndex
    End With
                                    
    If KeySet Then RotateCDKey Index, False, 0
    'key is issued to be changed
    
End Sub
'holds motd, last logon, and failed attempts

Private Sub Parse0x19(ByRef Index As Integer)
Dim MessageText As String, MessageCaption As String

    PBuffer.GetDWORD 'msg box type
    MessageText = PBuffer.GetNTstring 'text
    MessageCaption = PBuffer.GetNTstring 'caption

    AddChat 0, Index, vbYellow, GetString(152) & "(", vbWhite, MessageCaption, vbYellow, ") " & MessageText 'Notice --- Message from server:

End Sub
'bnet sent a message box, parse and display

Private Sub Parse0x73(Index As Integer)
  
    PBuffer.GetDWORD
    
    Select Case Asc(PBuffer.GetLenSTRING(1))
        Case &H7, &H2
            AddChat 0, botElements.ActiveChatIndex, RGB(192, 140, 0), GetString(128) 'Clan disban has failed.
        'failed
        Case &H0
            AddChat 0, botElements.ActiveChatIndex, RGB(192, 140, 0), GetString(129) 'Clan successfully has been disbanned.
        'success!
    End Select
  
End Sub
'clan disban reply

Private Sub Parse0x75(ByRef Index As Integer)
Dim sRankDisplay As String
    
    Call PBuffer.GetLenSTRING(1)
    'unknown
    aProfile(Index).RealClan = PBuffer.GetLenSTRING(4)
    If AscW(aProfile(Index).RealClan) <> 0 Then
        aProfile(Index).RealClan = StrReverse$(KillNull(aProfile(Index).RealClan))
    Else
        aProfile(Index).RealClan = KillNull(StrReverse$(aProfile(Index).RealClan))
    End If
    'for whatever reason the clan tag is sent differently while the clan is in its trial period.
    Dim theRank As Byte
    theRank = Asc(PBuffer.GetLenSTRING(1))
    Select Case theRank
        Case 0:  sRankDisplay = "Peon (New)"
        Case 1:  sRankDisplay = "Peon"
        Case 2:  sRankDisplay = "Grunt"
        Case 3:  sRankDisplay = "Shaman"
        Case 4:  sRankDisplay = "Chieftain"
    End Select
    'sets clan rank by name for display
    aProfile(Index).War3Rank = theRank
    '
    AddChat 0, Index, RGB(192, 140, 0), GetString(21) & aProfile(Index).RealClan & GetString(88) & sRankDisplay & EndBracketPeriod
    '~----------------------------              You are in clan [                         '] as a [
  
End Sub
'parses, displays, and sets what clan this profile is in


Private Sub Parse0x77(ByRef Index As Integer)

    If Left$(aProfile(Index).ClanArray(3), 1) <> "~" And Left$(aProfile(Index).ClanArray(3), 1) <> "1" And Left$(aProfile(Index).ClanArray(3), 1) <> "0" Then Exit Sub
    'if not local or cmd issued exit
    PBuffer.GetDWORD
    'cookie
    Dim EchoCommand As Boolean
    If Left$(aProfile(Index).ClanArray(3), 1) = "1" Then EchoCommand = True
    '
    Select Case Asc(PBuffer.GetLenSTRING(1))
        Case &H0
            If Left$(aProfile(Index).ClanArray(3), 1) = "~" Then
                AddChat 0, Index, RGB(192, 140, 0), GetString(113) & Mid$(aProfile(Index).ClanArray(3), 2) & GetString(125), Index, True '] has successfully been invited into the clan.
            'local
            Else
                QueueString GetString(113) & Mid$(aProfile(Index).ClanArray(3), 2) & GetString(125), Index, EchoCommand '] has successfully been invited into the clan.
            'announce it
            End If
        'has accepted the invite
        Case &H4, &H5, &H9
            If Left$(aProfile(Index).ClanArray(3), 1) = "~" Then
                AddChat 0, Index, RGB(192, 140, 0), GetString(113) & Mid$(aProfile(Index).ClanArray(3), 2) & GetString(126), Index, True '] was not invited into the clan.
            'local
            Else
                QueueString GetString(113) & Mid$(aProfile(Index).ClanArray(3), 2) & GetString(126), Index, EchoCommand '] was not invited into the clan.
            'announce it
            End If
        'declined, failed reply, clan full
    End Select
    
    aProfile(Index).ClanArray(3) = vbNullString
    'clr
  
End Sub
'parse invite results

Private Sub Parse0x4E(Index As Integer)
Dim sWCGname As String, sWCGwebsite As String

    With PBuffer
        .GetLenSTRING 1 'unknown
        .GetLenSTRING 1 'unknown
        sWCGname = .GetNTstring 'tourny name
        .GetNTstring 'unknown
        sWCGwebsite = .GetNTstring 'website
    End With
  
    AddChat 0, Index, RGB(192, 140, 0), GetString(90) & sWCGname  'You are competing in,
    AddChat 0, Index, RGB(192, 140, 0), GetString(91) & sWCGwebsite  'Official website,
    'adds chat
  
End Sub
'wcg reply of some sort

Private Sub Parse0x7E(Index As Integer)

    AddChat 0, Index, RGB(192, 140, 0), PBuffer.GetNTstring & GetString(89) ', was removed from the clan.
    'chat
    If botElements.LVState = 1 And Index = botElements.ActiveChatIndex Then
        PBuffer.InsertDWORD 0
        PBuffer.sendPacket &H7D, Index
    End If
    'confirm removal of clan member *update list*

End Sub
'clan removal status

Private Sub Parse0x7D(ByRef Index As Integer)
On Error GoTo Err
'
    Dim parseMethod As Byte, shamanIndex As Byte
    Dim clanShamans(4) As String, clanChieftain As String ' holds chieftains and shamans, used for parse methods 1+
    Dim whisperString As String, EchoCommand As Boolean 'pulled from remote _ commands
    '
    If Left$(aProfile(Index).ClanArray(3), 3) = "ddp" Then
        parseMethod = 1
    'indicate its a ddp
    ElseIf Left$(aProfile(Index).ClanArray(3), 2) = "ci" Then
        parseMethod = 2
        If Mid$(aProfile(Index).ClanArray(3), 3, 1) = "1" Then
            EchoCommand = True
        Else
            EchoCommand = False
        End If
        whisperString = Mid$(aProfile(Index).ClanArray(3), 4)
    'indicate its a clan info
    End If
    
    If botElements.LVState <> 1 And parseMethod = 0 Then Exit Sub
    'not correct window or not ddp

    If parseMethod = 0 Then frmMain.lvUserlist.ListItems.Clear
    'clear clan list window if not ddp
    
    Dim theName As String, theRank As Byte, OnlineIcon As Byte
    Dim listPosition As Integer
    Dim arrIndex As Integer, memberCount As Integer
    

    PBuffer.GetDWORD 'cookie
    memberCount = Asc(PBuffer.GetLenSTRING(1)) 'members in clan
    
    For arrIndex = 1 To memberCount
  
        If parseMethod = 0 Then
            With PBuffer
                theName = .GetNTstring
                theRank = Asc(.GetLenSTRING(1))
                If arrIndex < memberCount Then
                    OnlineIcon = Asc(.GetLenSTRING(1))
                    .GetNTstring 'location
                'blizzard doesnt send this info for the last user for some stupid reason. i can only assume
                'the last user is always the person checking, meaning online and location would be obvious
                Else
                    OnlineIcon = &H1
                End If
            End With
            'gets info
            
            If OnlineIcon = &H0 Then
                OnlineIcon = 31
            Else
                OnlineIcon = 30
            End If
            'sets online status
            
            If theRank = &H4 Then
                listPosition = 1
            'chieftain
            ElseIf theRank = &H3 Then
                If frmMain.lvUserlist.ListItems.Count = 0 Then
                    listPosition = 1
                'if no entries add to slot 1
                Else
                    listPosition = 2
                'if entries add to slot 2
                End If
            'shaman
            Else
                listPosition = (frmMain.lvUserlist.ListItems.Count + 1)
            'grunt or peon
            End If
        
            theRank = theRank + 41
            'sets the icon
        
            frmMain.lvUserlist.ListItems.Add listPosition, , theName, , theRank
            'add rank and name
            frmMain.lvUserlist.ListItems(listPosition).ListSubItems.Add , , , OnlineIcon
            'frmMain.lvUserlist.ListItems(listPosition).ListSubItems.Add , , vbNullString
            'add the online icon
        
            If OnlineIcon = 30 Then
            'if online then color
                If theRank = 44 Then
                    frmMain.lvUserlist.ListItems.Item(listPosition).ForeColor = &HC0FFFF
                'shaman
                ElseIf theRank = 45 Then
                    frmMain.lvUserlist.ListItems.Item(listPosition).ForeColor = &HFFC0C0
                'chieftain
                Else
                    frmMain.lvUserlist.ListItems.Item(listPosition).ForeColor = vbWhite
                'normal
                End If
            Else
                frmMain.lvUserlist.ListItems.Item(listPosition).ForeColor = &H808080
            'offline color, gray
            End If
            'colors
        'only do all this extra work if not ddp
        Else
            With PBuffer
                theName = .GetNTstring
                theRank = Asc(.GetLenSTRING(1))
                If arrIndex < memberCount Then
                    OnlineIcon = Asc(.GetLenSTRING(1)) 'online status
                    .GetNTstring 'location
                'blizzard doesnt send this info for the last user for some stupid reason. i can only assume
                'the last user is always the person checking, meaning online and location would be obvious
                End If
            End With
            'gets info
            If theRank = 3 Then
                If OnlineIcon = &H1 Or parseMethod = 2 Then
                    clanShamans(shamanIndex) = theName
                    shamanIndex = shamanIndex + 1
                End If
                'if online or get all shamans then set
            ElseIf theRank = 4 Then
                clanChieftain = theName
            'set chieftain
            End If
            'if is shaman add to list
            
        End If
        
    Next arrIndex
    
    If parseMethod = 1 Then
    'after we retrieve our results issue the queue if is ddp
        Dim ddpName As String
        ddpName = Mid$(aProfile(Index).ClanArray(3), 4)
        aProfile(Index).ClanArray(3) = vbNullString
        'set ddp name and reset var
        shamanIndex = 0
        'reset
        For shamanIndex = 0 To 4
            If LenB(clanShamans(shamanIndex)) <> 0 Then QueueString "/pfx/ddpd" & clanShamans(shamanIndex), Index, False, True
        Next shamanIndex
        'add demotes
        QueueString "/designate " & ddpName, Index, False, True
        QueueString "/resign", Index, False, True
        'add des and resign
        For shamanIndex = 0 To 4
            If LenB(clanShamans(shamanIndex)) <> 0 Then QueueString "/pfx/ddpp" & clanShamans(shamanIndex), Index, False, True
        Next
        'promote shamans again
    'this is a ddp
    ElseIf parseMethod = 2 Then
        Dim shamString As String
        For shamanIndex = 0 To 4
            If LenB(clanShamans(shamanIndex)) Then shamString = shamString & clanShamans(shamanIndex) & ", "
        Next
        'promote shamans again
        If LenB(shamString) Then
            shamString = Left$(shamString, Len(shamString) - 2)
            'remove comma space if has data
        Else
            shamString = "No Shamans"
        'lol no shamans?? okay then
        End If
        QueueString whisperString & "Chieftain: " & clanChieftain & " - Shamans: " & shamString & " - Member Count: " & memberCount, Index, EchoCommand
        'queue it up
    'this is shaman/chieftain name list
    End If
    
    
Err:
    If parseMethod = 0 Then
        frmMain.lblActiveChannelCount.Caption = frmMain.lvUserlist.ListItems.Count
        'sets count
        frmMain.lblActiveChannelName.Caption = "- Clan Information -"
        'sets caption
    End If
End Sub
'clan list/information received

Private Sub Parse0x41(Index As Integer)

    If Index <> botElements.CurrentActivePingIndex Then Exit Sub
    'not correct index exit
    botElements.ActivePing = (GTC - botElements.CurrentActivePingTick)
    'stores
    Set_ComboPrev "Active Ping: " & botElements.ActivePing & Space$(10) & "Filtered Items: " & aProfile(Index).FilterCount & Space$(10) & "Automatic Filters [ " & FiltersEnabledResponse(Index) & " ]", False
    'sets

End Sub
'parses banner link, we just use this to get active ping so index and data is irrelivant realyl

Private Sub Parse0x0A(ByRef Index As Integer)

    aProfile(Index).RealName = PBuffer.GetNTstring
    'set realname
    aProfile(Index).Connected = True
    'have to set before calling the config, so icons update properly
    If FormsOpen.Config Then frmConfiguration.Select_ViewingProfile
    'will cause the config to refresh icons
    Dim tabNumber As Integer
    If Val#(GetINI(INIGeneral, Str_HideTab, aProfile(Index).profilePath, 0)) = 1 Or Val#(GetINI(INIGeneral, "HideTab_Once", aProfile(Index).profilePath, 0)) = 1 Then
        HideProfileTab Index
        tabNumber = -1
        'so we dont perform any index specific things now that the tab is gone
        'since the tab was removed, if form is open then change current tab, just in case
    Else
        tabNumber = get_TabOnProfile(Index)
        'get the tab number for this profile, used for various events below
    End If
    'if the tab is to be hidden then do so
    'n// this has to be done first, otherwise get _ tab on profile will generate errors when handling icon
    'n// changes after first logging on
    
    
    Dim theTick As Currency
    theTick = GTC
    aProfile(Index).QueueRaiseFactorTick = theTick
    aProfile(Index).QueueWaitTick = (GTC + 3000)
    'make it so the user cant type anything within 3 seconds to protect against floods from greets, mail notices, ect
    'If Index = botElements.ActiveChatIndex Then
        'aProfile(Index).ChatIconChanged = False
    'Else
        'If aProfile(Index).Channel <> aProfile(botElements.ActiveChatIndex).Channel Then aProfile(Index).ChatIconChanged = True
    'End If
    'force a refresh if need be
    aProfile(Index).RealNameConverted = FirstNameConversion(aProfile(Index).RealName, Index)
    'sets realname with realm attached, this is to remove burden from the get _ access routine
    If aProfile(Index).GameClient = Str_PX2D Or aProfile(Index).GameClient = Str_VD2D Then aProfile(Index).RealName = "*" & aProfile(Index).RealName
    'gets unique name
    If tabNumber <> -1 Then Set_TabCaption Index
    'update with realname
    PBuffer.Clear
    PBuffer.InsertDWORD 0
    PBuffer.sendPacket &H46, Index
    'request news last logon and failed attempts
    aProfile(Index).UptimeTick = GTC
    'uptime
    aProfile(Index).PacketTimeout = 0
    aProfile(Index).ReconnectTick = 0
    aProfile(Index).ReconnectCount = 0
    aProfile(Index).Packet50Sent = False
    'resets retry values
    aProfile(Index).ServerToken = 0
    aProfile(Index).ClientToken = 0
    'wipes these, no longer needed
    AddChat 0, Index, vbGreen, GetString(20) & aProfile(Index).RealName & EndBracketPeriod 'Notice --- Logon complete, joining home channel.
    'chat to current index
    AddChat 0, 0, &HC0C0C0, GetString(99) & "Profile, " & aProfile(Index).Name & " - Index: " & Index & ", " & GetString(102) 'has been connected.
    'chat to status window
    If tabNumber <> -1 Then
        If aProfile(Index).ChatIconChanged Then
            frmMain.tabTable.Tabs(tabNumber).Image = 5
        'new chat
        Else
            frmMain.tabTable.Tabs(tabNumber).Image = 4
        'no new chat
        End If
        'logged on icon!
    End If
    'if tab is loaded
    If Index = botElements.ActiveChatIndex Then updateFrmMainCaption Index
    'displays unique name, ping ect
    If FormsOpen.Profile And Index = botElements.ActiveChatIndex Then frmProfile.SetToCaption Index
    'if profile viewer is open and the index being connected is the activechatindex then change profile set to caption
    If FormsOpen.ClanCreator Then
        'if frmclancreator.get_OpenerIndex
        If frmClanCreator.get_ProfileIndex = Index Then
            frmClanCreator.Set_ProfileIndex Index
            If Len(aProfile(Index).CDKey) <> 26 Then Unload frmClanCreator
            'not valid client ne more
        End If
        'if index is same one stored in clan creator
    End If
    'check clan creator stuff
    If FormsOpen.Access And tabNumber <> -1 Then
        If frmAccess.get_ProfileIndex = Index Then frmAccess.Set_ProfileIndex Index
        'if the viewing index is that of the one connecting
    End If
    'if filters n access is open
    
End Sub
'parse unique name response and finishes SC/W3 logon

Public Sub HideProfileTab(ByRef Index As Integer)
    Dim theTab As Integer
    theTab = get_TabOnProfile(Index)
    'frmmain.tabTable.Tabs.
    If theTab <> -1 Then
        aProfile(Index).TabHidden = True
        Set_ProfileOnTab True, , theTab
        'remove the tab this profile is on
        If botElements.ActiveChatIndex = Index Then
            SelectPreviousTab
        'if active tab then select the previously viewed
        Else
            theTab = get_TabOnProfile(botElements.ActiveChatIndex)
            If theTab = -1 Then
                SelectPreviousTab
            'if for some reason the tab being viewed while unloading the 'hide tab' profile cant be found default to previous tab.
            'this shouldnt happen but you never know
            Else
                frmMain.tabTable.SelectedItem = frmMain.tabTable.Tabs(theTab)
                handleTabTable_Click
            End If
            '
        'if not active tab then reselect the tab the user was viewing
        End If
        '
        If FormsOpen.Config Then frmConfiguration.SetFocus
        'assume focus was negated
    End If
End Sub

Private Sub Parse0x3D(Index As Integer)

    If PBuffer.GetLenSTRING(1) = AZero Then
        AddChat 0, Index, vbGreen, GetString(19) 'Notice --- Account creation successful.
        If botElements.AccountActivity Then printAccountActivity Index, 0
        'record creation date
        Send0x3A Index
        'logs in SC
    Else
        AddChat 0, Index, vbYellow, GetString(24) 'Notice --- Account creation failed.
        DisconnectProfile Index
    End If

End Sub
'account creation reply SC

Private Sub Parse0x3A(Index As Integer)

    Select Case AscB(PBuffer.GetLenSTRING(1))
        Case &H1
            AddChat 0, Index, vbGreen, GetString(47) 'Notice --- Account doesn't exist, creating.
            Send0x3D Index
            'create and send logon again
            Exit Sub
        Case &H2
            AddChat 0, Index, vbYellow, GetString(22) 'Notice --- Logon failed, invalid password.
            'add text
            aProfile(Index).Active = False
            'keeps the profile from reconnecting
        'invalid pass
        Case &H0
            With PBuffer
                .InsertNTString aProfile(Index).Name
                .InsertBYTE 0
                .sendPacket &HA, Index
                'to gather real name
                .InsertDWORD 2
                .InsertNTString aProfile(Index).ChannelHome
                .sendPacket &HC, Index
            End With
            'send enter chat packet
            Exit Sub
    End Select
  
    DisconnectProfile Index
  
End Sub
'parse sc login

Private Sub Send0x3D(Index As Integer)

    With PBuffer
        .InsertNonNTString hashPassword(aProfile(Index).Password)
        .InsertNTString aProfile(Index).Name
        .sendPacket &H3D, Index
    End With
  
End Sub
'creates an account for SC


Private Sub Parse0x52(Index As Integer)
  
    If (Len(aProfile(Index).CDKey) < 26) Then
        Exit Sub
    End If
        
    Select Case PBuffer.GetDWORD()
        Case &H0
            AddChat 0, Index, vbGreen, GetString(23) 'Notice --- Account creation successful.
            If botElements.AccountActivity Then printAccountActivity Index, 0
        'record creation date
        Send0x53 Index
        Case Else
            AddChat 0, Index, vbYellow, GetString(24) 'Notice --- Account creation failed.
            DisconnectProfile Index
    End Select

End Sub
'account creation reply (w3)
Private Sub Parse0x50(Index As Integer)
Dim ChecksumFormula As String
Dim EXEVersion As Long, ChecksumResult As Long, EXEinfo As String
Dim PublicValue As Long, ProductValue As Long
Dim KeyHash As String * 20, mpqName As String
Dim DLLTime1 As Long, DLLTime2 As Long

    With PBuffer
        .GetDWORD 'logon type
        aProfile(Index).ServerToken = .GetDWORD 'servertoken
        aProfile(Index).ClientToken = .GetDWORD 'UDPValue*
        DLLTime1 = .GetDWORD 'file time v
        DLLTime2 = .GetDWORD '-----------
        mpqName = .GetNTstring 'IX86ver filename
        ChecksumFormula = .GetNTstring 'hashed checksum
    End With
  
    If Not aProfile(Index).bnlsEnabled Then
    
        Dim sFile(3) As String
      
        If aProfile(Index).GameClient = Str_NB2W Then
            sFile(0) = App.Path & "\Hashes\w2bn\Warcraft II BNE.exe"
            sFile(1) = App.Path & "\Hashes\w2bn\Storm.dll"
            sFile(2) = App.Path & "\Hashes\w2bn\Battle.snp"
            sFile(3) = App.Path & "\Hashes\lockdown\w2bn.bin"
        'sets files w2
        ElseIf aProfile(Index).GameClient = Str_RATS Or aProfile(Index).GameClient = Str_PXES Then
            sFile(0) = App.Path & "\Hashes\star\Starcraft.exe"
            sFile(1) = App.Path & "\Hashes\star\Storm.dll"
            sFile(2) = App.Path & "\Hashes\star\Battle.snp"
            sFile(3) = App.Path & "\Hashes\lockdown\Star.bin"
        'sets files sc/bw
        ElseIf aProfile(Index).GameClient = Str_3RAW Or aProfile(Index).GameClient = Str_PX3W Then
            sFile(0) = App.Path & "\Hashes\war3\War3.exe"
            sFile(1) = App.Path & "\Hashes\war3\Storm.dll"
            sFile(2) = App.Path & "\Hashes\war3\Game.dll"
        'sets files w3 / w3xp
        ElseIf aProfile(Index).GameClient = Str_VD2D Then
          sFile(0) = App.Path & "\hashes\d2dv\Game.exe"
          sFile(1) = App.Path & "\hashes\d2dv\bnclient.dll"
          sFile(2) = App.Path & "\hashes\d2dv\d2client.dll"
        'sets files d2 reg
        ElseIf aProfile(Index).GameClient = Str_PX2D Then
            sFile(0) = App.Path & "\hashes\d2xp\Game.exe"
            sFile(1) = App.Path & "\hashes\d2xp\bnclient.dll"
            sFile(2) = App.Path & "\hashes\d2xp\d2client.dll"
        'sets files d2xp
        End If
        
        EXEinfo = Mid$(mpqName, InStr(mpqName, "-IX86-") + 6)
        If Not IsNumeric(Left$(EXEinfo, InStr(LCase$(EXEinfo), ".mpq") - 1)) Then
            AddChat 0, Index, vbYellow, GetString(25) 'Notice --- Couldn't extract MPQ number.
            DisconnectProfile Index
            Exit Sub
        'mpqnumber failed
        End If
    
        EXEinfo = String$(256, vbNullChar)
        Dim CRevResult As Long
        If InStrB(LCase$(mpqName), "ix86ver") Or InStrB(LCase$(mpqName), "ver-ix86") Then
            CRevResult = CheckRevisionA(sFile(0), sFile(1), sFile(2), ChecksumFormula, EXEVersion, ChecksumResult, EXEinfo, Left$(mpqName, Len(mpqName) - 4) & ".dll")
        Else
            CRevResult = CheckRevisionEx(sFile(0), sFile(1), sFile(2), ChecksumFormula, EXEVersion, ChecksumResult, EXEinfo, App.Path & "\Hashes\Lockdown\" & Left$(mpqName, Len(mpqName) - 4) & ".dll", vbNullString, sFile(3))
        End If
        'perform crev
    
        If CRevResult <> 1 Or EXEVersion = 0 Then
            If Len(aProfile(Index).CDKey) = 13 Then
                AddChat 0, Index, vbYellow, GetString(26) 'Notice --- Missing Starcraft / Broodwar hashes.
            'need hashes sc
            ElseIf aProfile(Index).GameClient = Str_NB2W Then
                AddChat 0, Index, vbYellow, GetString(27) 'Notice --- Missing Warcraft 2 hashes.
            'war2
            ElseIf aProfile(Index).GameClient = Str_VD2D Or aProfile(Index).GameClient = Str_PX2D Then
                AddChat 0, Index, vbYellow, GetString(28) 'Notice --- Missing Diablo 2 hashes.
            'war2
            Else
                AddChat 0, Index, vbYellow, GetString(29) 'Notice --- Missing Warcraft 3 hashes.
            'war3
            End If
            'check hash type for mesasge
            DisconnectProfile Index
            Exit Sub
        End If
        'bad hashes
        EXEinfo = KillNull(EXEinfo)
        'local hashing
        
    Else
        
        Select Case aProfile(Index).GameClient
            Case Str_RATS:   PBuffer.InsertDWORD &H1
            Case Str_PXES:   PBuffer.InsertDWORD &H2
            Case Str_NB2W:   PBuffer.InsertDWORD &H3
            Case Str_VD2D:   PBuffer.InsertDWORD &H4
            Case Str_PX2D:   PBuffer.InsertDWORD &H5
            Case Str_3RAW:   PBuffer.InsertDWORD &H7
            Case Str_PX3W:   PBuffer.InsertDWORD &H8
        End Select
        'insert client/product id
        With PBuffer
            .InsertDWORD &H0 'flags
            .InsertDWORD &H1 'cookie
            .InsertDWORD DLLTime1 '(ULONGLONG) Timestamp for version check archive.p1
            .InsertDWORD DLLTime2 '(ULONGLONG) Timestamp for version check archive.p2
            .InsertNTString mpqName 'mpq file name as a whole
            .InsertNTString ChecksumFormula 'formula
            .SendBNLSPacket &H1A, Index 'packetID
        End With
        'sends data req to bnls
        aProfile(Index).bnlsTimeoutTick = GTC
        'timeout set
        aProfile(Index).bnlsChecksumResult = 0
        'reset
        Do Until aProfile(Index).bnlsChecksumResult <> 0 Or GTC - aProfile(Index).bnlsTimeoutTick > 10000
            DoEvents
        Loop
        'wait for timeout
        If aProfile(Index).bnlsChecksumResult = 0 Then
            AddChat 0, Index, vbYellow, GetString(86) 'Notice --- BNLS packet reply has timed out, disconnecting.
            'chat
            DisconnectProfile Index
            'disc
            aProfile(Index).bnlsTimeoutTick = 0
            Exit Sub
        End If
        'check if we got result
        'AddChat 0, Index, vbGreen, GetSTRING(87) 'Notice --- BNLS hash information recieved, disconnecting from BNLS.
        'chat
        frmMain.Bnls_wS(Index).Close
        'we no longer need to be connected
        ChecksumResult = aProfile(Index).bnlsChecksumResult
        EXEVersion = aProfile(Index).bnlsEXEversion
        EXEinfo = aProfile(Index).bnlsEXEinfo
        'set
        aProfile(Index).bnlsChecksumResult = 0
        aProfile(Index).bnlsEXEversion = 0
        aProfile(Index).bnlsEXEinfo = vbNullString
        'clear
        Unload_BNLSwinsock Index
        'unload bnls as we no longer need it
    
    'if using bnls
    End If
    
    If kd_quick(aProfile(Index).CDKey, aProfile(Index).ClientToken, aProfile(Index).ServerToken, PublicValue, ProductValue, KeyHash, 20) = 0 Then
        AddChat 0, Index, vbYellow, GetString(31) 'Notice --- Couldn't decode cdkey [1].
        DisconnectProfile Index
        Exit Sub
    End If
    'decode cdkey (  1  )
    
'  Dim bRet() As Byte
'  cWarden.Initialize Left$(KeyHash, 4)
'  cWarden.StrToByteArray cWarden.GetBytes(&HF), bRet()
'  cWarden.SimpleCrypt bRet(), aProfile(Index).WardenKeyOut()
'  cWarden.StrToByteArray cWarden.GetBytes(&HF), bRet()
'  cWarden.SimpleCrypt bRet(), aProfile(Index).WardenKeyIn()
'  'warden keycodes
'w// -- remember to add Warden.cls to the project

    Dim KeyHolder As String
    Select Case Val#(GetINI(INIConnecting, Str_KeyUseName, , 0))
        Case 0: KeyHolder = "Alpha & Omega"
        Case 1: KeyHolder = aProfile(Index).CDKey
        Case 2: KeyHolder = aProfile(Index).Name
        Case 3: KeyHolder = "" & Left$(GetINI(INIConnecting, Str_KeyUseNameText, , "Alpha & Omega"), 14)
    End Select
    'selects the key in use method
    
    With PBuffer
        .InsertDWORD aProfile(Index).ClientToken
        .InsertDWORD EXEVersion
        .InsertDWORD ChecksumResult
        '----------
        If aProfile(Index).GameClient = Str_PX3W Or aProfile(Index).GameClient = Str_PX2D Then
            .InsertDWORD &H2 'keys sending (  2  )
        Else
            .InsertDWORD &H1 'keys sending (  1  )
        End If
        'how many keys being sent
        .InsertDWORD &H0 'Not using spawn.
        .InsertDWORD Len(aProfile(Index).CDKey)
        .InsertDWORD ProductValue
        .InsertDWORD PublicValue
        .InsertDWORD 0
        .InsertNonNTString KeyHash
        'key hash (  1  )
        If aProfile(Index).GameClient = Str_PX3W Or aProfile(Index).GameClient = Str_PX2D Then
            'if then
            PublicValue = 0
            ProductValue = 0
            KeyHash = vbNullString
            'just incase
            If kd_quick(aProfile(Index).CDKeyExpansion, aProfile(Index).ClientToken, aProfile(Index).ServerToken, PublicValue, ProductValue, KeyHash, 20) = 0 Then
                AddChat 0, Index, vbYellow, GetString(32) 'Notice --- Couldn't decode cdkey [2].
                DisconnectProfile Index
                Exit Sub
            End If
            'decode cdkey (  2  )
            .InsertDWORD Len(aProfile(Index).CDKeyExpansion)
            .InsertDWORD ProductValue
            .InsertDWORD PublicValue
            .InsertDWORD 0
            .InsertNonNTString KeyHash
            'key hash (  2  )
        End If
        'if expansion hash the second key
        .InsertNTString EXEinfo
        .InsertNTString KeyHolder
        .sendPacket &H51, Index
    End With
    'sends!
      
End Sub
'sends hashes, and cdkey hash



Private Sub Send0x53(ByRef Index As Integer)
Dim Var_A As String * 32

    If Not InitializeNLS(Index) Then Exit Sub
    'if couldnt initialize NLS
    
    Call nls_get_A(aProfile(Index).NLS, Var_A)
    'retrieve "public ephermeral value" 'A'
    
    With PBuffer
        .InsertNonNTString Var_A
        .InsertNTString aProfile(Index).Name
        .sendPacket &H53, Index
    End With
    
End Sub
'send w3 login


Private Sub Parse0x51(Index As Integer)
Dim rotateExpansion As Boolean

    Select Case PBuffer.GetDWORD
        Case &H0
            Select Case aProfile(Index).PingType
                Case 0, 2, 4
                    PBuffer.InsertNonNTString "tenb" 'no plug
                    PBuffer.sendPacket &H14, Index
                Case Else
            End Select
            'determine plug
        
            If LenB(aProfile(Index).Email1) And LenB(aProfile(Index).Email2) Then Send0x5B Index
            'change address
            If LenB(aProfile(Index).RecoveryEmail) Then Send0x5A Index
            'recover password
            aProfile(Index).RecoveryEmail = vbNullString
            aProfile(Index).Email1 = vbNullString
            aProfile(Index).Email2 = vbNullString
            If FormsOpen.Config Then
                frmConfiguration.TextBox(9).Text = vbNullString
                frmConfiguration.TextBox(10).Text = vbNullString
                frmConfiguration.TextBox(11).Text = vbNullString
            End If
            'null values
        
            If frmMain.wS(Index).State <> sckConnected Then Exit Sub
            'exit if we disconnected some where in there intentionally
            
            If LenB(aProfile(Index).NewPass) = 0 Then
                If aProfile(Index).GameClient = Str_3RAW Or aProfile(Index).GameClient = Str_PX3W Then
                    Send0x53 Index
                    'send w3 login
                Else
                    'Send0x3D Index 'creates sc account
                    'send create before this, since we cant send 0x3A after creation
                    'doesnt matter if account pre-exist no harm will come
                    Send0x3A Index 'send sc logon
                'send sc login
                End If
                'not a pass change
            Else
                If aProfile(Index).GameClient = Str_3RAW Then
                    Send0x55 Index
                    'changes w3 pass
                Else
                    Send0x31 Index 'change passwword sc
                End If
                'change pass
                Exit Sub
            End If
            'if pass change exit sub, dont process email change and pass change at once
                
            Exit Sub
            'cdkey is good send logon
    Case &H100
            AddChat 0, Index, vbYellow, GetString(33) 'Notice --- Old product version.
            'RotateCDKey Index, False
        Case &H101
            AddChat 0, Index, vbYellow, GetString(34) 'Notice --- Invalid product version.
            'RotateCDKey Index, False
        Case &H200
            AddChat 0, Index, vbYellow, GetString(35) 'Notice --- Invalid cdkey, IPBanned.
            aProfile(Index).ReconnectCount = 7 'user is ipbanned, cancel reconnect retries
            RotateCDKey Index, False, 2
        Case &H201
            AddChat 0, Index, vbYellow, GetString(36) & PBuffer.GetNTstring 'Notice --- CDkey is in use by,
            RotateCDKey Index, False, 3
        Case &H202
            AddChat 0, Index, vbYellow, GetString(37) 'Notice --- CDKey is banned from battleNet.
            RotateCDKey Index, False, 1
        Case &H203
            AddChat 0, Index, vbYellow, GetString(38) 'Notice --- CDKey is meant for another product.
            RotateCDKey Index, False, 4
        Case &H211
            AddChat 0, Index, vbYellow, GetString(210) & PBuffer.GetNTstring 'Notice --- Expansion CDkey is in use by,
            RotateCDKey Index, True, 3
        Case &H213
            AddChat 0, Index, vbYellow, GetString(145) 'Notice --- Expansion CDKey is meant for another product.
            RotateCDKey Index, True, 4
    End Select

    DisconnectProfile Index
    'if we're here something went wrong

End Sub
'cdkey check reply

Public Sub RotateCDKey(ByRef Index As Integer, ByRef ExpansionKey As Boolean, ByRef ChangeReason As Byte)

    If Not botElements.RotateCDKeys Then Exit Sub
    'exit if feature is not enabled
    DisconnectProfile Index
    'disc the profile
    'theres a chance this will be called twice upon in use, invalid ect, but shouldnt hurt nething
    Dim FirstCDKey As String, OldCDKey As String, INIString As String
    '
    'sets to compare against
    Dim FileNumber As Integer, FileNumber2 As Integer, fileName As String, fileData As String, keyIndex As Integer, dataIndex As Integer
    '
    If ExpansionKey Then
    'set file to expansion keys
        INIString = "Expansion"
        OldCDKey = LCase$(aProfile(Index).CDKeyExpansion)
        fileName = App.Path & "\Text\CDKeys_Expansions.txt"
    Else
    'set file to reg keys
        INIString = vbNullString 'since not expansion we do not need to need to add a suffix
        OldCDKey = LCase$(aProfile(Index).CDKey)
        fileName = App.Path & "\Text\CDKeys.txt"
    End If
    '
    If Len(OldCDKey) < 13 Then Exit Sub
    'all keys are 13 or higher in length, this shoudlnt happen
    keyIndex = GetINI(INIConnecting, "CDKey" & INIString & "Index", aProfile(Index).profilePath, 0)
    'set starting index as current key index
    'will have previous indexes already in use
    Dim inuseKey As Boolean, arrIndex As Integer
    '
    FileNumber = FreeFile
    Open fileName For Input As #FileNumber
    'to read k eys
    FileNumber2 = FreeFile 'used for appending the bad key to a file, and reading the bad key file
    Dim BadKeys As String
    If LenB(Dir$(App.Path & "\Text\Bad_CDKeys.txt")) Then
        Open App.Path & "\Text\Bad_CDKeys.txt" For Input As #FileNumber2
        Do Until EOF(FileNumber2)
            Line Input #FileNumber2, fileData
                BadKeys = BadKeys & AZero & Left$(fileData, InStr(fileData, ASpace) - 1) & AOne
        Loop
        Close #FileNumber2
    End If
    'load bad keys
    
    Do Until EOF(FileNumber)
        Line Input #FileNumber, fileData
        fileData = LCase$(fileData)
        'to compare
        If InStrB(fileData, ASpace) Then fileData = Replace$(fileData, ASpace, vbNullString)
        If InStrB(fileData, ADash) Then fileData = Replace$(fileData, ADash, vbNullString)
        'replace junk chars
        If InStrB(BadKeys, AZero & fileData & AOne) Then GoTo RotateCDKey_NextKey
        'if in bad list skip
        If LenB(fileData) = LenB(OldCDKey) Then
        'if same length as the key we will be replacing
            If LenB(FirstCDKey) = 0 Then FirstCDKey = fileData
            'incase we go through the whole list, set the key as this
            If dataIndex > keyIndex And fileData <> OldCDKey Then
            'if new key isnt the same as old then
                For arrIndex = 1 To UBound(aProfile)
                    If aProfile(Index).Active Then
                    'if profile is set to be connected
                        If ExpansionKey Then
                            If aProfile(arrIndex).CDKeyExpansion = fileData Then
                                inuseKey = True
                                Exit For
                            End If
                            'not a match
                        'if expansion key being changed
                        Else
                            If aProfile(arrIndex).CDKey = fileData Then
                                inuseKey = True
                                Exit For
                            End If
                            'not a match
                        End If
                    End If
                    'if profile is active
                Next arrIndex
                'check all loaded keys
                If Not inuseKey Then
                    FirstCDKey = fileData
                    GoTo RotateCDKey_CloseFile
                End If
                'if new key has been found
            End If
            'if key isnt same as current
            dataIndex = dataIndex + 1
            'next index
        End If
RotateCDKey_NextKey:
    Loop
    'loop through whole file
    dataIndex = 0
    'if here then entire key index has been run through and were using the first key which would be 0
RotateCDKey_CloseFile:
    Close #FileNumber
    'set key and close
    If LenB(FirstCDKey) Then
    'if data exist process
        If OldCDKey <> FirstCDKey Then
        'if keys differ then set new
            AddChat 0, Index, vbYellow, GetString(179) & "Old cdkey, " & Left$(UCase$(OldCDKey), 4) & "..." & Right$(UCase$(OldCDKey), 4) 'CDKey will be automatically changed upon next reconnect.
            'add chat
            WriteINI INIConnecting, "CDKey" & INIString, FirstCDKey, aProfile(Index).profilePath
            WriteINI INIConnecting, "CDKey" & INIString & "Index", dataIndex, aProfile(Index).profilePath
            'write cd key raw and its new index
            If ExpansionKey Then
                aProfile(Index).CDKeyExpansion = FirstCDKey
            Else
                aProfile(Index).CDKey = FirstCDKey
            End If
            'apply new key
        Else
        'no new key
            AddChat 0, Index, vbYellow, GetString(180) & "Current cdkey, " & Left$(UCase$(OldCDKey), 4) & "..." & Right$(UCase$(OldCDKey), 4) 'No additional CDKeys were found, your cdkey will not be rotated.
        End If
    End If
    
    
    Open App.Path & "\Text\Bad_CDKeys.txt" For Append As #FileNumber2
    Select Case ChangeReason
        Case 0: Print #FileNumber2, OldCDKey & " 'voided_or_muted"
        'voided or muted
        Case 1: Print #FileNumber2, OldCDKey & " 'banned"
        'banned
        Case 2: Print #FileNumber2, OldCDKey & " 'invald"
        'invalid
    End Select
    Close #FileNumber2
    If ChangeReason >= 0 And ChangeReason < 3 And FormsOpen.Config Then
        With frmConfiguration
            .Get_ConfigCDKeys
            .Set_ClientKeys
        End With
    End If
    'if the config is open reload keys
    
End Sub
'loads a new cdkey for the supplied index

Private Sub Send0x5A(ByRef Index As Integer)
    
    AddChat 0, Index, vbGreen, GetString(39) 'Notice --- Account registration recovery sent.
    'chat
    DoEvents
    PBuffer.InsertNTString aProfile(Index).Name
    PBuffer.InsertNTString aProfile(Index).RecoveryEmail
    PBuffer.sendPacket &H5A, Index
    'packet
    aProfile(Index).Active = False
    'so it doesnt auto reconnect
    DisconnectProfile Index
    'disc
End Sub
'recovers an account

Private Sub Send0x5B(Index As Integer)
    
    AddChat 0, Index, vbGreen, GetString(40) 'Notice --- Account registration email change sent.
    'chat
    If botElements.AccountActivity Then printAccountActivity Index, 3
    'lo g
    DoEvents
    PBuffer.InsertNTString aProfile(Index).Name
    PBuffer.InsertNTString aProfile(Index).Email1
    PBuffer.InsertNTString aProfile(Index).Email2
    PBuffer.sendPacket &H5B, Index

End Sub
'changes email registration address


Private Sub Send0x3A(Index As Integer)
  
    With PBuffer
        .InsertDWORD aProfile(Index).ClientToken
        .InsertDWORD aProfile(Index).ServerToken
        .InsertNonNTString doubleHashPassword(aProfile(Index).Password, aProfile(Index).ClientToken, aProfile(Index).ServerToken)
        .InsertNTString aProfile(Index).Name
        .sendPacket &H3A, Index
    End With
  
End Sub
'send logon SC

Private Sub Send0x55(ByRef Index As Integer)
Dim a As String * 32
      
    If Not InitializeNLS(Index) Then Exit Sub
    '
    With PBuffer
        Call nls_get_A(aProfile(Index).NLS, a)
        .InsertNonNTString a
        .InsertNTString aProfile(Index).Name
        .sendPacket &H55, Index
    End With
  
End Sub
'request to change a pass to a W3 account, auth

Private Function InitializeNLS(ByRef Index As Integer) As Boolean
    
    FreeNLS Index
    'release if already assigned
    aProfile(Index).NLS = nls_init(aProfile(Index).Name, aProfile(Index).Password)
    If aProfile(Index).NLS = 0 Then
        AddChat 0, Index, vbYellow, GetString(50) 'Notice --- Couldn't initialize NLS.
        DisconnectProfile Index
    Else
        InitializeNLS = True
    End If
    'start nls
    
End Function
'attempts to start nls

Private Sub Parse0x55(Index As Integer)
Dim ServerKey As String, Salt As String, NewPW As String
Dim NewNLS As Long, OutputBuffer As String * 84
    
    Select Case PBuffer.GetDWORD
        Case &H0
        'okay for change, trying
        Case &H1
            AddChat 0, Index, vbYellow, GetString(21) 'Notice --- Account doesn't exist, reconnect.
            DisconnectProfile Index
            GoTo Err
        Case &H5
            AddChat 0, Index, vbYellow, GetString(51) 'Notice --- Account requires upgrade.
            DisconnectProfile Index
            GoTo Err
        Case Else
            AddChat 0, Index, vbYellow, GetString(52) 'Notice --- Unhandled password change failure.
            DisconnectProfile Index
            GoTo Err
    End Select
      
    Salt = PBuffer.GetLenSTRING(32)
    ServerKey = PBuffer.GetLenSTRING(32)
    
    NewPW = aProfile(Index).NewPass
    NewNLS = nls_account_change_proof(aProfile(Index).NLS, OutputBuffer, NewPW, ServerKey, Salt)
      
    If NewNLS = 0 Then
        AddChat 0, Index, vbYellow, GetString(41) 'Notice --- Couldn't create account password change packet.
        DisconnectProfile Index
        Exit Sub
    End If
      
    aProfile(Index).OldNLS = aProfile(Index).NLS
    aProfile(Index).NLS = NewNLS
          
    PBuffer.InsertNonNTString OutputBuffer
    PBuffer.sendPacket &H56, Index
    
Err:
End Sub
'change pw war3

Public Sub printAccountActivity(Index As Integer, iType As Byte)
 
    Dim FileNumber As Integer
    FileNumber = FreeFile
    '
    Open App.Path & "\Text\AccountActivity.txt" For Append As #FileNumber
    'open file
    Select Case iType
        Case 0
            Print #FileNumber, "Account Created:  " & aProfile(Index).Name & "  -  " & aProfile(Index).BNETServer & "  -  " & StrReverse$(aProfile(Index).GameClient) & "  -  " & Date$ & "_" & Time$
        'created
        Case 1
            Print #FileNumber, "Password Changed:  " & aProfile(Index).Name & "  -  " & aProfile(Index).BNETServer & "  -  " & StrReverse$(aProfile(Index).GameClient) & "  -  " & aProfile(Index).Password & " / " & aProfile(Index).NewPass & "  -  " & Date$ & "_" & Time$
        'pw change
        Case 2
            Print #FileNumber, "Account Registered:  " & aProfile(Index).Name & "  -  " & aProfile(Index).BNETServer & "  -  " & StrReverse$(aProfile(Index).GameClient) & "  -  " & GetINI(INIConnecting, "RegistrationEmail") & "  -  " & Date$ & "_" & Time$
        'account registered to email
        Case 3
            Print #FileNumber, "Account Email Changed:  " & aProfile(Index).Name & "  -  " & aProfile(Index).BNETServer & "  -  " & StrReverse$(aProfile(Index).GameClient) & "  -  " & aProfile(Index).Email1 & " / " & aProfile(Index).Email2 & "  -  " & Date$ & "_" & Time$
        'account email change
    End Select
    'print
    Close #FileNumber
  
End Sub
'stores account activity

Private Sub Parse0x31(Index As Integer)
      
    If PBuffer.GetLenSTRING(1) = AZero Then
        AddChat 0, Index, vbYellow, GetString(42) 'Notice --- Account password change failed.
        aProfile(Index).NewPass = vbNullString
        'failed
        DisconnectProfile Index
    Else
        AddChat 0, Index, vbGreen, GetString(43) 'Notice --- Account password change successful.
        'change good
        If botElements.AccountActivity Then printAccountActivity Index, 1
        'save
        aProfile(Index).Password = aProfile(Index).NewPass
        aProfile(Index).NewPass = vbNullString
        'reset
        WriteINI INIConnecting, TPassword, aProfile(Index).Password, aProfile(Index).profilePath
        'saves results to the ini
        Send0x3A Index
        'finish logon
    End If
    
    If FormsOpen.Config Then frmConfiguration.TextBox(8) = vbNullString
    'null txtfield
    
End Sub
'account password change reply SC

Private Sub Send0x31(Index As Integer)

    AddChat 0, Index, vbGreen, GetString(44) 'Notice --- Attempting to change account password.
    
    With PBuffer
        .InsertDWORD aProfile(Index).ClientToken
        .InsertDWORD aProfile(Index).ServerToken
        .InsertNonNTString doubleHashPassword(aProfile(Index).Password, aProfile(Index).ClientToken, aProfile(Index).ServerToken)
        .InsertNonNTString hashPassword(aProfile(Index).NewPass)
        .InsertNTString aProfile(Index).Name
        .sendPacket &H31, Index
    End With
  
End Sub
'sends password change request SC

'Private Sub Parse0x5E(Index As Integer)
'Dim bData()       As Byte
'Dim bRet()        As Byte
'Dim sData         As String
'Dim lPos          As Long
'Dim nFile         As Integer
'Dim EventNo       As Byte
'Dim I             As Long
'Dim Loops         As Long
'Static Vals()     As String 'was dim
'Static addR()     As Long 'was dim
'Dim readlen       As Byte
'Dim ToSend        As String
'Static Checksum   As Long 'was dim
'Const Req1        As Long = &H497FB0
'Const Req2        As Long = &H49C33D
'Const Req3        As Long = &H4A2FF7
'
'  sData = PBuffer.GetInboundData
'  cWarden.StrToByteArray sData, bData()
'  cWarden.DoCrypt bData(), aProfile(Index).WardenKeyIn(), bRet(), Index
'  Select Case bRet(0)
'    Case &H0
'      ReDim Vals(0)
'      ReDim addR(0)
'      PBuffer.Clear
'      ReDim bData(0)
'      bData(0) = &H1
'      cWarden.DoCrypt bData(), aProfile(Index).WardenKeyOut(), bRet(), Index
'      PBuffer.InsertNonNTString cWarden.ByteArrayToStr(bRet())
'      PBuffer.sendPacket &H5E, Index
'      'warden logon verification sent
'    Case &H2
'      Loops = (Len(sData) - 3) / 7
'      If (Loops - 1) > UBound(addR) Then
'        If LenB(Dir$(App.Path & "\Hashes\Star\Starcraft.exe")) > 0 Then
'          EventNo = bRet(1)
'          ReDim Vals(Loops - 1) As String
'          ReDim addR(Loops - 1) As Long
'          nFile = FreeFile
'          Open App.Path & "\Hashes\Star\Starcraft.exe" For Binary Access Read As #nFile
'          lPos = 2
'          For I = 0 To Loops - 1
'            lPos = lPos + 2
'            CopyMemory addR(I), bRet(lPos), 4
'            lPos = lPos + 4
'            readlen = bRet(lPos)
'            lPos = lPos + 1
'            Vals(I) = String$(readlen, 0)
'            Get #nFile, addR(I) - &H400000 + 1, Vals(I)
'          Next I
'          Close #nFile
'        'sc exe found get new values
'        Else
'          AddChat 0, Index, vbYellow, GetSTRING(148) 'Notice --- Starcraft.exe has gone missing! Warden disconnect soon.
'          Exit Sub
'        End If
'        If addR(0) = Req1 And addR(1) = Req2 And addR(2) = Req3 Then
'          Checksum = &H193E73E8
'        ElseIf addR(0) = Req2 And addR(1) = Req1 And addR(2) = Req3 Then
'          Checksum = &HD6557DEF
'        ElseIf addR(0) = Req1 And addR(1) = Req3 And addR(2) = Req2 Then
'          Checksum = &H2183172A
'        ElseIf addR(0) = Req2 And addR(1) = Req3 And addR(2) = Req1 Then
'          Checksum = &HCA841860
'        ElseIf addR(0) = Req3 And addR(1) = Req2 And addR(2) = Req1 Then
'          Checksum = &H9F2AD2C3
'        ElseIf addR(0) = Req3 And addR(1) = Req1 And addR(2) = Req2 Then
'          Checksum = &HC04CF757
'        Else
'          AddChat 0, Index, vbYellow, GetSTRING(149) 'Notice --- Unknown Warden request, you will be disconnected in two minutes.
'          Exit Sub
'        End If
'      End If
'      'get new values if changed
'      PBuffer.Clear
'      For I = 0 To Loops - 1
'          PBuffer.InsertBYTE &H0
'          PBuffer.InsertNonNTString Vals(I)
'      Next I
'      ToSend = PBuffer.GetOutboundData
'      ToSend = Chr$(&H2) & PBuffer.MakeWORD(Len(ToSend)) & PBuffer.MakeDWORD(Checksum) & ToSend
'      cWarden.StrToByteArray ToSend, bData()
'      PBuffer.Clear
'      cWarden.DoCrypt bData(), aProfile(Index).WardenKeyOut(), bRet(), Index
'      PBuffer.InsertNonNTString cWarden.ByteArrayToStr(bRet())
'      PBuffer.sendPacket &H5E, Index
'      'warden stay alive sent
'    Case Else
'      AddChat 0, Index, vbYellow, GetSTRING(150) 'Notice --- Recieved an unhandled Warden packet.
'  End Select
'End Sub
'w// -- remember to add Warden.cls to the project

Private Sub Parse0x56(Index As Integer)
Dim M2 As String
  
    Select Case PBuffer.GetDWORD
        Case &H0
            M2 = PBuffer.GetLenSTRING(20)
            If (nls_check_M2(aProfile(Index).OldNLS, M2, vbNullString, vbNullString) = 0) Then
                AddChat 0, Index, vbYellow, GetString(45) 'Notice --- Server account password change proof failed.
                '
                DisconnectProfile Index
            End If
            'check proof
            AddChat 0, Index, vbGreen, GetString(46) 'Notice --- Account password change successful.
            'chat
            If botElements.AccountActivity Then printAccountActivity Index, 1
            'lo g
            aProfile(Index).Password = aProfile(Index).NewPass
            aProfile(Index).NewPass = vbNullString
            'resets
            WriteINI INIConnecting, TPassword, aProfile(Index).Password, aProfile(Index).profilePath
            'saves results to the ini
            Send0x53 Index
        'send logon
        Case &H2
            AddChat 0, Index, vbYellow, GetString(53) 'Notice --- Account password change failed, incorrect old password.
            aProfile(Index).NewPass = vbNullString
            DisconnectProfile Index
        Case Else
            AddChat 0, Index, vbYellow, GetString(54) 'Notice --- Unhandled password change failure [2].
            DisconnectProfile Index
    End Select

    If FormsOpen.Config Then frmConfiguration.TextBox(8).Text = vbNullString
    'null entry

End Sub
'pass change authproof reply w3


Private Sub Parse0x53(Index As Integer)

    Select Case PBuffer.GetDWORD
        Case &H0: 'Logon accepted
        Case &H1
            AddChat 0, Index, vbGreen, GetString(47) 'Notice --- Account doesn't exist, creating.
            Send0x52 Index
            Exit Sub
        'account doesnt exist, create
        Case &H5
            AddChat 0, Index, vbYellow, GetString(51) 'Notice --- Account requires upgrade.
            Exit Sub
        Case Else
            AddChat 0, Index, vbYellow, GetString(55) 'Notice --- Unhandled logon failure.
            Exit Sub
    End Select
  
    Dim M1 As String * 20, Salt As String, Var_B As String

    Salt = PBuffer.GetLenSTRING(32)
    Var_B = PBuffer.GetLenSTRING(32)
     
    Call nls_get_M1(aProfile(Index).NLS, M1, Var_B, Salt)
    'get password proof
  
    With PBuffer
        .InsertNonNTString M1
        .sendPacket &H54, Index
    End With

End Sub
'logon auth reply W3

Private Sub Send0x52(Index As Integer)
Dim sBuffer As String, lBuffer As Long
  
    lBuffer = 65 + Len(aProfile(Index).Name)
    sBuffer = String$(lBuffer, vbNullChar) ' Initialize buffer
    'prep
    If nls_account_create(aProfile(Index).NLS, sBuffer, lBuffer) = 0 Then
        AddChat 0, Index, vbYellow, GetString(56) 'Notice --- Couldn't create account creation packet.
        Exit Sub
    End If
    'old product version?
    
    With PBuffer
        .InsertNonNTString sBuffer
        .sendPacket &H52, Index
    End With
  
End Sub
'creates a w3 account

Private Sub RegisterAccountEmail(ByRef Index As Integer)
  
    If Val#(GetINI(INIConnecting, Str_RegisterAccounts)) = 1 And LenB(GetINI(INIConnecting, Str_RegisterEmail)) Then
        AddChat 0, Index, vbGreen, GetString(140) 'Notice --- Account registration sent.
        'chat
        If botElements.AccountActivity Then printAccountActivity Index, 2
        'lo g
        PBuffer.InsertNTString GetINI(INIConnecting, Str_RegisterEmail)
        PBuffer.sendPacket &H59, Index
    End If
    'if enabled then

End Sub
'registers an account to an email

Private Sub Parse0x54(Index As Integer)
Dim pReply As Long

    pReply = PBuffer.GetDWORD
    'stores case
    Select Case pReply
        Case &H0, &HE
            FreeNLS Index
            'release nls
            If pReply = &HE Then RegisterAccountEmail Index
            'send email registration
            Send0xABC Index
            Exit Sub
        'allset
        Case &H2
            AddChat 0, Index, vbYellow, GetString(48) 'Notice --- Account closed, or invalid password.
            If GetINI(INIGeneral, Str_InvalidPasswordRC) = 0 Then 'if not reconnect then
                DisconnectProfile Index
                aProfile(Index).Active = False 'disables it from r/c
            End If
        'prolly invalid pass, but some times this can be a false positive
        Case Else
            AddChat 0, Index, vbYellow, GetString(49) 'Notice --- Unhandled logon failure.
        'yep
    End Select
    
    DisconnectProfile Index
    'logon failed
  
End Sub
'logon proof reply W3

Private Sub Send0xABC(Index As Integer)
  
    With PBuffer
        .InsertNTString aProfile(Index).Name
        .InsertBYTE &H0
        .sendPacket &HA, Index
        .InsertNonNTString Str_3RAW
        .sendPacket &HB, Index
        .InsertDWORD &H1 '&h2
        .InsertNTString aProfile(Index).ChannelHome
        .sendPacket &HC, Index
        .InsertDWORD &H2
        .InsertNTString aProfile(Index).ChannelHome '&h1 to attempt to get into clan channel, and &h2 to move to last or configured channel
        .sendPacket &HC, Index
    End With

End Sub
'w3 conection successful,enter chat

Public Sub Send0x50(Index As Integer)

    'make sure names and passwords arent too long which could cause an ipban
    aProfile(Index).Name = Left$(aProfile(Index).Name, 15)
    aProfile(Index).Password = Left$(aProfile(Index).Password, 15)
    aProfile(Index).NewPass = Left$(aProfile(Index).NewPass, 15)
    

    frmMain.wS(Index).SendData ChrW(1)

    With PBuffer
        .InsertDWORD &H0
        .InsertNonNTString "68XI"
        .InsertNonNTString aProfile(Index).GameClient
    
        Select Case aProfile(Index).GameClient
            Case Str_3RAW, Str_PX3W:      .InsertDWORD "&H" & botElements.VerbyteW3    'w3/xp
            Case Str_VD2D, Str_PX2D:      .InsertDWORD "&H" & botElements.VerbyteD2    'd2/xp
            Case Str_PXES, Str_RATS:      .InsertDWORD "&H" & botElements.VerbyteSC    'sc/xp
            Case Str_NB2W:              .InsertDWORD "&H" & botElements.VerbyteW2    'w2
        End Select
        'verbyte
    
        .InsertDWORD &H0
        .InsertDWORD &H0
        .InsertDWORD &H0
        .InsertDWORD &H0
        .InsertDWORD &H0
        .InsertNTString "USA"
        .InsertNTString "United States"
        .sendPacket &H50, Index
    End With
    'sending & h 50

    aProfile(Index).Packet50Sent = True
    'ping types 0norm 1norm-p 2zero 3zero-p 4negative 5negative-p
    If aProfile(Index).PingType < 2 Then DoEvents
    'normal / normal plug
    
    If aProfile(Index).PingType < 4 Then
        PBuffer.InsertDWORD 0
        PBuffer.sendPacket &H25, Index
    End If
    'normal / zero ping

End Sub
'sends 0x50


Public Sub FreeNLS(Index As Integer)
  
    If aProfile(Index).NLS <> 0 Then
        Call nls_free(aProfile(Index).NLS)
        aProfile(Index).NLS = 0
    End If
  
    If aProfile(Index).OldNLS <> 0 Then
        Call nls_free(aProfile(Index).OldNLS)
        aProfile(Index).OldNLS = 0
    End If
  
End Sub
'releases NLS



'=====================================
'======== EXTRA PACKET WORK ==========
'=====================================

Private Sub Parse0x26(Index As Integer)
  
  If FormsOpen.Profile Then frmProfile.displayProfile Index
  'parse request
  
End Sub
'relays to parseprofile

Public Function Send0x27(sSex As String, sLocation As String, sDescription As String, Index As Integer) As Boolean

    If Not aProfile(Index).Connected Then Exit Function
    'exit if not connected

    If (Len(sSex) + Len(sLocation) + Len(sDescription)) > 525 Then sDescription = Left$(sDescription, 525 - (Len(sSex) + Len(sLocation)))
    'chops description if too long
  
    With PBuffer
        .InsertDWORD 1
        .InsertDWORD 3
        .InsertNTString aProfile(Index).Name
        .InsertNTString "profile\sex"
        .InsertNTString "profile\location"
        .InsertNTString "profile\description"
        .InsertNTString sSex
        .InsertNTString sLocation
        .InsertNTString sDescription
        .sendPacket &H27, Index
    End With
  
    Send0x27 = True
    'shows it has been done

End Function
'sets profile

Public Sub Send0x26(sProfileName As String, Index As Integer)

    If InStrB(sProfileName, "*") Then sProfileName = Mid$(sProfileName, InStr(sProfileName, "*") + 1)
    'removes * from d2
  
    aProfile(Index).BNETProfileLookupName = sProfileName

    With PBuffer
        .InsertDWORD 1
        .InsertDWORD 3
        .InsertDWORD 1
        .InsertNTString sProfileName
        .InsertNTString "profile\sex"
        .InsertNTString "profile\location"
        .InsertNTString "profile\description"
        .sendPacket &H26, Index
    End With

End Sub
'request a profile


Private Sub Parse0x65(Index As Integer)

    If botElements.LVState <> 2 Then Exit Sub
    'exit if not viewing friendslist tab
    AddChat 0, Index, RGB(192, 140, 0), GetString(8) 'Friends list recieved.
    'friends list recieved chat
    Dim friendEntries As Byte, entrySlot As Byte
    friendEntries = Asc(PBuffer.GetLenSTRING(1))
    'number of users on f list
    frmMain.lvUserlist.ListItems.Clear
    'clears userlist
    Dim sName As String, iStatus As Byte, iLocation As Byte
    Dim sClient As String, sTitle As String, iOnlineIcon As Byte
    'vars
    
    Do Until entrySlot = friendEntries
      
        With PBuffer
            sName = .GetNTstring
            iStatus = Asc(.GetLenSTRING(1)) '0-not_mutual 1-mutual 2-dnd 3-away
            iLocation = Asc(.GetLenSTRING(1)) '0-offline 1-not_in_chat 2-in_chat 3-pugGame 4-privGame_not_friend 5-privGame_friend
            sClient = .GetLenSTRING(4)
            sTitle = .GetNTstring
        End With
        
        If iLocation = 0 Then
            iOnlineIcon = 31
        'offline
        Else
            If iLocation > 2 Then
                If iStatus = 0 Or iLocation = 4 Then
                    iOnlineIcon = 46
                'not mutual in game, same as not mutual out of game
                Else
                    iOnlineIcon = 29
                'mutual in game
                End If
            Else
                If iStatus = 0 Then
                    iOnlineIcon = 39
                'not mutual not in game
                Else
                    iOnlineIcon = 30
                'mutual online not in game
                End If
            End If
            'online
        End If
            
        If iOnlineIcon <> 31 Then
            Dim sClientSplit() As String
            sClientSplit = Split(GetClient(sClient, 0, vbNullString, Index), ACross)
            'splits client
            frmMain.lvUserlist.ListItems.Add frmMain.lvUserlist.ListItems.Count + 1, , sName, , Val#(sClientSplit(2))
        'adds CLIENT icon to a player online
        Else
            frmMain.lvUserlist.ListItems.Add frmMain.lvUserlist.ListItems.Count + 1, , sName, , iOnlineIcon
        'not online
        End If
        'adds name + client icon
        frmMain.lvUserlist.ListItems(frmMain.lvUserlist.ListItems.Count).ListSubItems.Add , , , iOnlineIcon, sTitle
        'adds online/off icon
    
        If iOnlineIcon = 31 Then
            frmMain.lvUserlist.ListItems.Item(frmMain.lvUserlist.ListItems.Count).ForeColor = &H808080
        'user offline - gray
        Else
            If iOnlineIcon = 30 Then
                frmMain.lvUserlist.ListItems.Item(frmMain.lvUserlist.ListItems.Count).ForeColor = vbWhite
            'online not in game
            Else
                frmMain.lvUserlist.ListItems.Item(frmMain.lvUserlist.ListItems.Count).ForeColor = &HC0FFFF
            'online but in game
            End If
        'online
        End If
    
        entrySlot = entrySlot + 1

    Loop
  
    frmMain.lblActiveChannelName = "- Friends List -"
    frmMain.lblActiveChannelCount = frmMain.lvUserlist.ListItems.Count
    'shows captions
  

    If Err.Number <> 0 Then handleProjectError Index, "Error:sub|Parse0x65 -> [" & Err.Number & "] " & Err.Description
End Sub
'show friends list

Private Sub Parse0x70(Index As Integer)
  
    If FormsOpen.ClanCreator Then
    
      PBuffer.GetDWORD 'cookie
      Dim iCanidatesAvailable As Byte
    
      Select Case Asc(PBuffer.GetLenSTRING(1))
      Case &H0
          iCanidatesAvailable = Asc(PBuffer.GetLenSTRING(1)) 'canidates available
          AddChat 0, botElements.ActiveChatIndex, &H8000&, "Tag ", vbGreen, frmClanCreator.txtClanTag.Text, &H8000&, " is available. Found ", vbGreen, iCanidatesAvailable, &H8000&, GetString(93), vbGreen, frmClanCreator.txtClanTag.Text, &H8000&, GetString(94) & Left$(UCase$(aProfile(Index).CDKey), 5) & "..."
        '~~~~~~~~~~~~~~~~                                                                                                                                'canidates for                                         'on key,
      'clan tag is available -w- # canidates
      Case &H1
          AddChat 0, Index, &H8080&, GetString(95), vbYellow, frmClanCreator.txtClanTag.Text, &H8080&, GetString(96)  'Clan tag,   'is already taken.
      'tag is already taken
      Case &H8
          AddChat 0, Index, vbYellow, GetString(97)  'You are already in a clan and cannot create one.
       'youre already in a clan
      Case &HA
          AddChat 0, Index, &H8080&, GetString(95), vbYellow, frmClanCreator.txtClanTag.Text, &H8080&, GetString(98)  'Clan tag,   'is not valid.
      'invalid clan tag
      Case Else
      '  AddChat 0, 1, vbYellow, "ELSE: " & Asc(Mid$(sData, 4, 1))
      End Select
      'replies with clan tag avail
    
      Dim iCanidateSlot As Byte
      'parses to usernames only
      Do Until iCanidateSlot = iCanidatesAvailable
          frmClanCreator.LstAvail.AddItem PBuffer.GetNTstring
          iCanidateSlot = iCanidateSlot + 1
      Loop
      'adds to avail list (will be null if availability fails so no worries
  
    End If
    'only run check if the clan creator is open
  
    If Err.Number <> 0 Then handleProjectError Index, "Error:sub|Parse0x70 -> [" & Err.Number & "] " & Err.Description
End Sub

Private Sub Parse0x72(Index As Integer)
Dim sClanName As String

    With PBuffer
        aProfile(Index).ClanArray(0) = .GetLenSTRING(4) 'token/cookie
        aProfile(Index).ClanArray(1) = .GetLenSTRING(4) 'clan tag
        sClanName = .GetNTstring 'clan name
        aProfile(Index).ClanArray(2) = .GetNTstring 'inviter
    End With
          
    aProfile(Index).ClanArray(3) = "create"
    'type
    Dim displayTag As String
    displayTag = StrReverse$(KillNull(aProfile(Index).ClanArray(1)))
    '
    AddChat 0, Index, &H8000&, GetString(107), vbGreen, displayTag, &H8000&, " -- clan name ", vbGreen, sClanName, &H8000&, " -- inviter ", vbGreen, aProfile(Index).ClanArray(2), &H8000&, GetString(108)
    '~~~~~                        'Clan invitation recieved, Tag   'TAG                                                                                 'clan_name                                      'inviter                            '. Type /create to accept the clan creation invite.
    If FormsOpen.ClanCreator Then
        If LCase$(StrReverse$(KillNull(aProfile(Index).ClanArray(1)))) = LCase$(frmClanCreator.txtClanTag) And frmClanCreator.CheckClanAutoAccept.Value = vbChecked Then
            Send0x72 True, True, Index
        End If
        'if matching and auto accept then
    End If
    'check for auto accept

    '  If Err.Number <> 0 Then PBuffer.Clear
    If Err.Number <> 0 Then handleProjectError Index, "Error:sub|Parse0x72 -> [" & Err.Number & "] " & Err.Description
    
End Sub
'clan creation invite recieved

Private Sub Parse0x79(ByRef Index As Integer)

    With PBuffer
        aProfile(Index).ClanArray(0) = .GetLenSTRING(4) 'cookie
        aProfile(Index).ClanArray(1) = .GetLenSTRING(4) 'tag
        aProfile(Index).ClanArray(2) = .GetNTstring 'clan name
        aProfile(Index).ClanArray(3) = .GetNTstring 'clan leader/inviter
    End With
  
    If botElements.Invites Then
        QueueString GetString(110) & KillNull(StrReverse$(aProfile(Index).ClanArray(1))) & ". Type " & aProfile(Index).AccessTrigger & "accept to join the clan.", Index, False, True
    Else
        AddChat 0, Index, &H8000&, GetString(110), vbGreen, StrReverse$(KillNull(aProfile(Index).ClanArray(1))), &H8000&, GetString(111)
    '~~~~~~~~~~~~~                     'Clan joining invitation recieved, tag                 '. Type /accept to join the clan.
    End If
    
    aProfile(Index).ClanArray(2) = "join"
    'usually would use ( 3 ) but its needed in the end
  
End Sub
'war3 invite, being invited to exiting

Public Sub Send0x79(bAcceptInvite As Boolean, Index As Integer)

    If aProfile(Index).ClanArray(2) <> "join" Then Exit Sub
    'if not proper type
  
    With PBuffer
        .InsertNonNTString aProfile(Index).ClanArray(0) 'cookie/token
        .InsertNonNTString aProfile(Index).ClanArray(1) 'tag
        .InsertNTString aProfile(Index).ClanArray(3) 'the inviter
        If bAcceptInvite Then
            .InsertBYTE &H6
        'accept
        Else
            .InsertBYTE &H4
        'decline
        End If
        .sendPacket &H79, Index
        'accepts
    End With
  
    AddChat 0, Index, &H8000&, GetString(112), vbGreen, StrReverse$(KillNull(aProfile(Index).ClanArray(1)))
    'chat                              'Clan joining invite has been accepted, tag
    
    aProfile(Index).ClanArray(0) = vbNullString
    aProfile(Index).ClanArray(1) = vbNullString
    aProfile(Index).ClanArray(2) = vbNullString
    aProfile(Index).ClanArray(3) = vbNullString
    'reset

End Sub
'accept/decline clan JOIN invite

Public Sub Send0x72(bAcceptInvite As Boolean, bAutoAccept As Boolean, Index As Integer)

    If aProfile(Index).ClanArray(3) <> "create" Then Exit Sub
    'if not proper type
    With PBuffer
        .InsertNonNTString aProfile(Index).ClanArray(0) 'token
        .InsertNonNTString aProfile(Index).ClanArray(1) 'tag
        .InsertNTString aProfile(Index).ClanArray(2) 'inviter
        '
        If bAcceptInvite Then
            .InsertBYTE &H6
            'accept
        Else
            .InsertBYTE &H4
            'decline
        End If
        '
        .sendPacket &H72, Index
    End With
    'sends clan creation packet

    Dim displayTag As String
    displayTag = StrReverse$(KillNull(aProfile(Index).ClanArray(1)))
    '

    AddChat 0, Index, &H8000&, GetString(109), vbGreen, displayTag, &H8000&, " unique-name ", vbGreen, aProfile(Index).RealName
     'chat                              'Clan creation invite has been accepted, tag
  
    If bAutoAccept Then
        If Index <> botElements.ActiveChatIndex Then AddChat 0, botElements.ActiveChatIndex, &H8000&, "(" & AttachRealmSingle(aProfile(Index).RealName, Index) & ") " & GetString(109), vbGreen, displayTag, &H8000&, " unique-name ", vbGreen, aProfile(Index).RealName
        'chat again
    End If
  'add chat to active chat index as well if not already

    aProfile(Index).ClanArray(0) = vbNullString
    aProfile(Index).ClanArray(1) = vbNullString
    aProfile(Index).ClanArray(2) = vbNullString
    aProfile(Index).ClanArray(3) = vbNullString
    'reset

End Sub
'accepts a clan creation invite, or declines it


Public Sub PacketLog(ByVal sData As String, ByVal pID As Byte, ByVal bOut As Boolean, ByVal daIndex As Integer, ByVal bBNLS As Boolean)
On Error GoTo Err

  Dim sHexii As String, sChars As String
  Dim sHextmp As String, iNewline As Byte

  sChars = "[" & daIndex & "] &H" & Hex(pID)
  If bOut Then
    sChars = sChars & " -out-> " & bBNLS
  Else
    sChars = sChars & " <-in- " & bBNLS
  End If
  'grabs header
  sChars = sChars & vbCrLf
  'sets header

  Do Until LenB(sData) = 0
    If Asc(sData) = 9 Then
      sChars = sChars & " TB"
    Else
      sChars = sChars & "  " & Left$(sData, 1)
    End If
    'sets chars
    sHextmp = Hex(AscB(sData))
    If Len(sHextmp) = 1 Then sHextmp = "0" & sHextmp
    'double digit
    sHexii = sHexii & " " & sHextmp
    'kk
    sData = Mid$(sData, 2)
    'next char
    iNewline = iNewline + 1
    If iNewline > 40 Then
      iNewline = 0
      'reset, new line
      sChars = sChars & vbCrLf & sHexii & vbCrLf
      sHexii = vbNullString
    End If
    'add new line
  Loop

  Dim fFree As Integer
  fFree = FreeFile
  Open App.Path & "\Packetlog.txt" For Append As #fFree
  Print #fFree, sChars & vbCrLf & sHexii & vbCrLf & vbCrLf
  Close #fFree
  'print

Err:
End Sub
'f// for debugging packets. uncomment this, and uncomment the other f // entry to use






