﻿Imports System.Threading
Imports System.Net
Imports System.IO

Public Class Form1
    Private Declare Function GetPrivateProfileString Lib "kernel32.dll" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As System.Text.StringBuilder, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
    'for reading and writing INI files
    Dim isUpdating As Boolean
    Dim myVersion As Integer = 0
    Dim DownloadUrl As String = "http://vpben.byethost8.com/proj/ano/"

    Private Function GetINI(ByVal Section As String, ByVal Key As String, Optional ByVal writeNulls As String = vbNullString) As String
        Dim intCharCount As Integer
        Dim objResult As New System.Text.StringBuilder(256)

        intCharCount = GetPrivateProfileString(Section, Key, Key, objResult, objResult.Capacity, Application.StartupPath & "\Text\someChatConfig.ini")
        If intCharCount > 0 Then
            Return objResult.ToString.Substring(0, intCharCount)
        Else
            Return writeNulls
        End If
    End Function
    'get an ini result

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        BeginTransfers()

    End Sub
    'update clicked

    Private Sub BeginTransfers()
        Button3.Enabled = False
        Button1.Enabled = False
        Button2.Enabled = False
        'disable buttons
        isUpdating = True
        '
        WriteText("Downloading file requirements...")
        '
        ThreadPool.QueueUserWorkItem(New WaitCallback(AddressOf DownloadFileRequirements))
        'start a new thread so the ui doesnt lag
    End Sub
    Private Sub DownloadFileRequirements()

        Try

            Dim RequiredFiles As String
            Dim StringClient As New WebClient
            RequiredFiles = StringClient.DownloadString(DownloadUrl & "file_requirements2.txt")
            If RequiredFiles.Substring(0, 7) = "Delete|" Then
                SetFormProperty("Download successful.", -2, -2, vbNullString, vbNullString, False, False)
                Dim MainSplit() As String = Split(RequiredFiles, ChrW(10))
                Dim EachSplit() As String
                Dim mainIndex As Byte, EachIndex As Byte
                Dim FilesDownload As String = vbNullString
                Dim FilesDelete As String = vbNullString
                '
                If UBound(MainSplit) > 0 Then
                    'if proper ubound

                    EachSplit = Split(MainSplit(0), "|")
                    'files to be deleted
                    For EachIndex = 1 To UBound(EachSplit)
                        If InStr(FilesDelete, ChrW(0) & EachSplit(EachIndex) & ChrW(1)) = 0 And EachSplit(EachIndex) <> "NA" Then
                            'NA signifies no files to be deleted
                            FilesDelete += ChrW(0) & EachSplit(EachIndex) & ChrW(1)
                            'build onto files string
                            If Len(Dir(Application.StartupPath & "\" & EachSplit(EachIndex))) <> 0 Then
                                SetFormProperty(vbNullString, -2, -2, EachSplit(EachIndex), vbNullString, False, False)
                                'add to list if file exist
                            End If
                        End If
                    Next EachIndex
                    'creates files to be deleted list

                    Dim pathLocation As Byte, tmpFile As String, tmpFile2 As String
                    'below handles files to be updated/downloaded
                    For mainIndex = 1 To UBound(MainSplit)
                        If InStr(MainSplit(mainIndex), "|") Then
                            'If contains markers
                            EachSplit = Split(MainSplit(mainIndex), "|")
                            If Integer.Parse(EachSplit(0)) > myVersion Then
                                'if higher than pretend current version
                                For EachIndex = 1 To UBound(EachSplit)
                                    If InStr(FilesDownload, ChrW(0) & EachSplit(EachIndex) & ChrW(1)) = 0 Then
                                        FilesDownload += ChrW(0) & EachSplit(EachIndex) & ChrW(1)
                                        'build onto files string
                                        tmpFile2 = vbNullString
                                        tmpFile = Replace(EachSplit(EachIndex), "/", "\")
                                        pathLocation = InStr(tmpFile, "\")
                                        Do Until pathLocation = 0
                                            tmpFile2 = tmpFile2 & Mid(tmpFile, 1, pathLocation)
                                            makeDirectory(Application.StartupPath & "\" & tmpFile2)
                                            'create
                                            tmpFile = Mid(tmpFile, pathLocation + 1)
                                            'parse
                                            pathLocation = InStr(tmpFile, "\")
                                        Loop
                                        'create directories

                                        SetFormProperty(vbNullString, -2, -2, vbNullString, EachSplit(EachIndex), False, False)
                                        'add to list
                                    End If
                                Next EachIndex
                                '
                            End If
                        End If
                    Next
                    If LstDownload.Items.Count <> 0 Then SetFormProperty("Downloading updated files...", -2, -2, vbNullString, vbNullString, False, False)
                    'determine if user needs to update
TryNextFile:
                    Do Until LstDownload.Items.Count = 0
                        DownloadFile(DownloadUrl & "files/" & LstDownload.Items.Item(0) & ".dl", Application.StartupPath & "\" & Replace(LstDownload.Items.Item(0), "/", "\"))
                        SetFormProperty(vbNullString, -2, -2, vbNullString, vbNullString, True, False)
                        'download and remove from list
                    Loop
                    'proceed to download files
                    DeleteFiles()
                    'delete files no longer needed
                    SetFormProperty("You are up to date! If files did not download properly use the 'Repair Files' option.", -2, -2, vbNullString, vbNullString, False, False)
                Else
                    'not proper ubound
                    SetFormProperty("Couldn't parse file requirement list, update failed.", -2, -2, vbNullString, vbNullString, False, False)
                End If
                'if within this if contains proper starting char
            End If

        Catch ex As Exception
            SetFormProperty("Error Updating: " & ex.Message.ToString, -2, -2, vbNullString, vbNullString, True, False)
            If LstDownload.Items.Count <> 0 Then GoTo TryNextFile

            'show it errored
        Finally
            isUpdating = False
            'unset
        End Try

    End Sub
    'downloads a list of files that need to be updated, and proceeds to download them

    Private Sub WriteText(ByRef theText As String)
        TxtReport.Text += theText & vbCrLf
        TxtReport.SelectionLength = 0
        TxtReport.SelectionStart = Len(TxtReport.Text)
        TxtReport.ScrollToCaret()
    End Sub
    'writes to my textbox

    Private Sub DownloadFile(ByRef FileSource As String, ByRef FileDestination As string)

        Dim request As WebRequest
        Dim response As WebResponse
        Dim reader As Stream
        Dim writer As Stream
        Dim data(1023) As Byte
        Dim count As Integer
        Dim total As Integer

        Application.DoEvents()

        SetFormProperty("Requesting " & LstDownload.Items.Item(0) & "...", -2, -2, vbNullString, vbNullString, False, False)

        request = WebRequest.Create(FileSource)
        response = request.GetResponse()
        reader = response.GetResponseStream()

        SetFormProperty("Downloading " & Format((response.ContentLength / 1024), "#0.00") & "KB", 0, CInt(response.ContentLength), vbNullString, vbNullString, False, False)

        total = 0
        writer = File.Create(FileDestination)

        While True
            count = reader.Read(data, 0, 1024)
            If count <= 0 Then
                Exit While
            End If

            writer.Write(data, 0, count)

            total += 1024
            If total < ProgressBar1.Maximum Then SetFormProperty(vbNullString, total, -2, vbNullString, vbNullString, False, False)
            Application.DoEvents()
        End While
        reader.Close()
        writer.Close()
        'finished saving to file

        SetFormProperty("Download Complete!", 0, 1, vbNullString, vbNullString, False, False)

    End Sub

    Private Sub makeDirectory(ByRef thePath As String)
        On Error Resume Next
        MkDir(thePath)
    End Sub

    Private Sub DeleteFiles()
        On Error Resume Next
        If LstDelete.Items.Count = 0 Then Exit Sub
        'exit if no files to delete
        SetFormProperty("Deleting unused files...", -2, -2, vbNullString, vbNullString, False, False)
        Do Until LstDelete.Items.Count = 0
            SetFormProperty("Deleting " & LstDelete.Items.Item(0), -2, -2, vbNullString, vbNullString, False, False)
            Kill(Application.StartupPath & "\" & Replace(LstDelete.Items.Item(0), "/", "\"))
            SetFormProperty(vbNullString, -2, -2, vbNullString, vbNullString, False, True)
        Loop
        SetFormProperty("Deletion complete!", -2, -2, vbNullString, vbNullString, False, False)
    End Sub
    'deletes old files

    Private Delegate Sub FormPropertyDelegate(ByVal TxtReport_Text As String, ByVal ProgressBar1_Value As Integer, ByVal ProgressBar1_Maximum As Integer, ByVal LstDelete_Item As String, ByVal LstDownload_Item As String, ByVal RemoveDownload As Boolean, ByVal RemoveDelete As Boolean)
    Private Sub SetFormProperty(ByVal TxtReport_Text As String, ByVal ProgressBar1_Value As Integer, ByVal ProgressBar1_Maximum As Integer, ByVal LstDelete_Item As String, ByVal LstDownload_Item As String, ByVal RemoveDownload As Boolean, ByVal RemoveDelete As Boolean)
        'When this sub is called, test which thread we are in.'InvokeRequired does this, it returns true if the control
        'cannot be accessed in the current thread
        If Me.InvokeRequired Then

            'We are in the wrong thread.
            'Use a delegate to call this sub again from the correct thread:
            Dim Delegate1 As New FormPropertyDelegate(AddressOf SetFormProperty)
            'Need to send the sub parameters, use an object:
            Dim DataRelayed(6) As Object
            DataRelayed(0) = TxtReport_Text
            DataRelayed(1) = ProgressBar1_Value
            DataRelayed(2) = ProgressBar1_Maximum
            DataRelayed(3) = LstDelete_Item
            DataRelayed(4) = LstDownload_Item
            DataRelayed(5) = RemoveDownload
            DataRelayed(6) = RemoveDelete
            'set vars
            Me.Invoke(Delegate1, DataRelayed)
            'Call the sub again:
        Else
            'this time the sub was called from the correct thread
            If Len(TxtReport_Text) <> 0 Then WriteText(TxtReport_Text)
            If ProgressBar1_Value <> -2 Then ProgressBar1.Value = ProgressBar1_Value
            If ProgressBar1_Maximum <> -2 Then ProgressBar1.Maximum = ProgressBar1_Maximum
            If Len(LstDelete_Item) <> 0 Then LstDelete.Items.Add(LstDelete_Item)
            If Len(LstDownload_Item) <> 0 Then LstDownload.Items.Add(LstDownload_Item)
            If RemoveDownload And LstDownload.Items.Count <> 0 Then LstDownload.Items.RemoveAt(0)
            If RemoveDelete And LstDelete.Items.Count <> 0 Then LstDelete.Items.RemoveAt(0)
        End If

    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim versionAnnouncer As String, expectedVersion As Integer
        myVersion = Val(GetINI("Updater", "Version", "100048"))
        expectedVersion = Val(GetINI("Updater", "eVersion"))
        'if not specified assume version is 100034, since thats lowest version that supports this updater
        If myVersion < 100048 Then
            versionAnnouncer = "Your version is not at expected value. It is suggested you use the 'Repair Files' option."
            myVersion = 100048
        Else
            versionAnnouncer = "Your version is: " & myVersion & ", expected version is: " & expectedVersion
        End If
        'user had probably tampered with files fi this is the case
        WriteText(versionAnnouncer)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Static writtenSwitch As Boolean = False

        If isUpdating Then Exit Sub
        'dont do this while updating
        Dim windowOpen As Boolean
        For Each p As Process In Process.GetProcesses
            If p.MainWindowTitle = "AlphaNOmega_C" Then
                windowOpen = True
                Exit For
            End If
            'ano is still open
        Next
        'check for the closing of a&o

        If Not windowOpen Then
            Button1.Enabled = True
            Button2.Enabled = True
            Button3.Enabled = True
            If writtenSwitch Then
                WriteText("you may now access update or repair.")
                writtenSwitch = False
            End If
        Else
            Button1.Enabled = False
            Button2.Enabled = False
            Button3.Enabled = False
            'disable
            If Not writtenSwitch Then
                WriteText("Waiting for Alpha & Omega to close...")
                writtenSwitch = True
            End If
        End If


    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Me.Hide()
        'hide
        Shell(Application.StartupPath & "\Alpha & Omega.exe")
        'launch
        End
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        myVersion = 100047
        'set base version
        BeginTransfers()
    End Sub
    'repair clicked
End Class
